﻿EnableExplicit

Structure Single_TOKEN_PRIVILEGE
  PrivilegeCount.i
  pLuid.LARGE_INTEGER
  Attributes.i
  EndStructure

Procedure AquirePrivilege(PrivilegeName.s)
  CompilerIf #PB_Compiler_Unicode
    Define.i xLong1
    Define.Single_TOKEN_PRIVILEGE xType1

    If OpenProcessToken_(GetCurrentProcess_(), 40, @xLong1)
      If LookupPrivilegeValue_(0, @PrivilegeName, @xType1\pLuid)
        xType1\PrivilegeCount = 1
        xType1\Attributes = 2
        AdjustTokenPrivileges_(xLong1, 0, @xType1, 0, 0, 0)
        EndIf
      CloseHandle_(xLong1)
      EndIf
    CompilerEndIf
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 7
; Folding = -
; EnableUnicode
; EnableXP