EnableExplicit

Procedure.i GetTickTimeMS()
  Define.i xResult
  xResult = GetTickCount_() & $3FFFFFFF
  If xResult = 0
    xResult = $3FFFFFFF
    EndIf
  ProcedureReturn xResult
  EndProcedure

Macro TickTimeMSAndMask()
  $3FFFFFFF
  EndMacro

Macro TickTimeMSMod()
  $40000000
  EndMacro

Macro GetTickTimeMSEx()
  (GetTickCount_() & $3FFFFFFF)
  EndMacro

Procedure.i GetElapsedTickTimeMS(FirstTickCountValue.i)
  Define.i xLong1

  xLong1 = GetTickCount_() & $3FFFFFFF
  If xLong1 < FirstTickCountValue
    xLong1 = xLong1 + $40000000 - FirstTickCountValue
    Else
    xLong1 = (xLong1 - FirstTickCountValue)
    EndIf
  ProcedureReturn xLong1
  EndProcedure

Procedure.i IsTickTimeElapsedMS(FirstTickCountValue.i, TimeIntervalMs.i)
  Define.i xLong1

  If FirstTickCountValue = 0
    xLong1 = #True
    Else
    xLong1 = GetTickCount_() & $3FFFFFFF
    If xLong1 < FirstTickCountValue
      If (xLong1 + $40000000 > FirstTickCountValue + TimeIntervalMs)
        xLong1 = #True
        Else
        xLong1 = #False
        EndIf
      Else
      If (xLong1 > FirstTickCountValue + TimeIntervalMs)
        xLong1 = #True
        Else
        xLong1 = #False
        EndIf
      EndIf
    EndIf
  ProcedureReturn xLong1
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 35
; FirstLine = 32
; Folding = --
; EnableUnicode
; EnableXP