﻿EnableExplicit

LibBuild_Include(LoadResEx_WEMF_MultiOS)
CompilerIf #PB_Compiler_Processor = #PB_Processor_x64 Or #PB_Compiler_Unicode
  LibBuild_Include(IconFromEMF)
  CompilerElse
  LibBuild_Include(IconFromWMF)
  CompilerEndIf

Procedure.i LoadResEx_ImageIconWEMF_MultiOS(ResID.i, SizeX.i = 0, SizeY.i = 0)
  Define.i xResult
  Define.i hMeta

  hMeta = LoadResEx_WEMF_MultiOS(ResID)
  If hMeta
    CompilerIf #PB_Compiler_Unicode Or #PB_Compiler_Processor = #PB_Processor_x64
      xResult = IconFromEMF(hMeta, SizeX, SizeY)
      DeleteEnhMetaFile_(hMeta)
      CompilerElse
      xResult = IconFromWMF(hMeta, SizeX, SizeY)
      DeleteMetaFile_(hMeta)
      CompilerEndIf
    EndIf
  CompilerIf Defined(LibBuild_LoadResEx_Image_MultiOS_Included, #PB_Constant)
    If Not xResult
      xResult = LoadResEx_Image_MultiOS(ResID, 1, SizeX, SizeY)
      EndIf
    CompilerEndIf
  ProcedureReturn xResult
  EndProcedure

Macro LoadResEx_ImageIconWEMF_MultiOS_Big(ResID)
  LoadResEx_ImageIconWEMF_MultiOS(ResID, GetSystemMetrics_(#SM_CXICON), GetSystemMetrics_(#SM_CYICON))
  EndMacro

Macro LoadResEx_ImageIconWEMF_MultiOS_Small(ResID)
  LoadResEx_ImageIconWEMF_MultiOS(ResID, GetSystemMetrics_(#SM_CXSMICON), GetSystemMetrics_(#SM_CYSMICON))
  EndMacro

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 23
; FirstLine = 15
; Folding = --
; EnableUnicode
; EnableXP