EnableExplicit

LibBuild_Include(SoundSchemes_Core)
LibBuild_Include(BinaryBuffer_MoreReadData)
LibBuild_Include(BinaryBuffer_ReadStringLP)
LibBuild_Include(BinaryBuffer_SetReadOffset)

Procedure.i SoundSchemes_Write(*SchemePointer, SchemeName.s, Caption.s)
  Define.i xResult
  Define.i xFail
  Define.i hKey
  Define.i xLong1
  Define.i xLong2
  Define *Mem
  Define.s xChar1

  If *SchemePointer And Len(SchemeName)
    SchemeName = "\" + SchemeName
    While BinaryBuffer_MoreReadData(*SchemePointer)
      xChar1 = BinaryBuffer_ReadStringLP(*SchemePointer)
      BinaryBuffer_ReadMemExI(*SchemePointer, xLong1)
      BinaryBuffer_ReadMemExI(*SchemePointer, xLong2)
      If xLong2
        *Mem = BinaryBuffer_ReadMemEx(*SchemePointer, 0, xLong2)
        Else
        *Mem = *ptrTemp
        EndIf
      ;Debug "D:" + xChar1 + SchemeName + "=" + Str(xLong1) + "/" + Str(xLong2) + "/" ;+ PeekS(*Mem)
      xChar1 = "AppEvents\Schemes\Apps\" + xChar1 + SchemeName
      If RegCreateKeyEx_($80000001, @xChar1, 0, 0, 0, 2, 0, @hKey, *ptrTemp)
        xFail = #True
        Break
        EndIf
      If RegSetValueEx_(hKey, 0, 0, xLong1, *Mem, xLong2)
        xFail = #True
        Break
        EndIf
      RegCloseKey_(hKey)
      Wend
    BinaryBuffer_SetReadOffset(*SchemePointer, 0)
    If Not xFail
      xResult = #True
      EndIf
    If Len(Caption)
      xChar1 = "AppEvents\Schemes\Names" + SchemeName
      If Not RegCreateKeyEx_($80000001, @xChar1, 0, 0, 0, 2, 0, @hKey, *ptrTemp)
        CompilerIf #PB_Compiler_Unicode
          RegSetValueEx_(hKey, 0, 0, 1, @Caption, (Len(Caption) + 1) << 1)
          CompilerElse
          RegSetValueEx_(hKey, 0, 0, 1, @Caption, Len(Caption) + 1)
          CompilerEndIf
        RegCloseKey_(hKey)
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 5
; FirstLine = 2
; Folding = -
; EnableUnicode
; EnableXP