﻿EnableExplicit

LibBuild_Include(TxtFileReader_Core)

Procedure.i TxtFileReader_FromMemory(*Mem, xSize.i, DefaultEncoding = #CP_ACP)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define *xType1.TxtFileReadStruct

  *xType1 = MemAlloc(SizeOf(TxtFileReadStruct))
  If *xType1
    If xSize > 1
      MemCopyRTL(@xLong1, *Mem, 2)
      If (xLong1 & $FFFF) = $FEFF
        DefaultEncoding = #CP_WINUNICODE
        *Mem + 2
        xSize - 2
        ElseIf xSize > 2
        MemCopyRTL(@xLong1, *Mem, 3)
        If (xLong1 & $FFFFFF) = $BFBBEF
          DefaultEncoding = #CP_UTF8
          *Mem + 3
          xSize - 3
          EndIf
        EndIf
      EndIf
    If xSize = 0
      xResult = *xType1
      Else
      If DefaultEncoding = #CP_WINUNICODE
        If Not (xSize & 1)
          *xType1\hMem = MemAllocNC(xSize + 6)
          If *xType1\hMem
            MemCopyRTL(*xType1\hMem, *Mem, xSize)
            xResult = *xType1
            EndIf
          EndIf
        Else
        xLong1 = MultiByteToWideChar_(DefaultEncoding, 0, *Mem, xSize, 0, 0)
        If xLong1
          *xType1\hMem = MemAllocNC((xLong1 << 1) + 8)
          If *xType1\hMem
            xLong2 = MultiByteToWideChar_(DefaultEncoding, 0, *Mem, xSize, *xType1\hMem, xLong1)
            If xLong1 = xLong2
              xSize = xLong1 << 1
              xResult = *xType1
              EndIf
            EndIf
          EndIf
        EndIf
      If xResult
        *xType1\Encoding = DefaultEncoding
        *xType1\hMemPos = *xType1\hMem
        *xType1\hMemEnd = *xType1\hMem + xSize
        PokeW(*xType1\hMemEnd+0, 13)
        PokeW(*xType1\hMemEnd+2, 10)
        PokeW(*xType1\hMemEnd+4,  0)
        xResult = *xType1
        ElseIf *xType1\hMem
        MemFree(*xType1\hMem)
        EndIf
      EndIf
    If Not xResult
      MemFree(*xType1)
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP