﻿EnableExplicit

LibBuild_Include(TxtFileReader_Core)

Procedure.i TxtFileReader_SetEncodingReset(*hTxtFileIn.TxtFileReadStruct, Encoding.i)
  Define.i xResult
  Define.TxtFileReadStruct xType2
  Define *hMemMB
  Define.i xSizeOrg.i
  Define.i xSizeNew.i
  Define.i xLong1.i

  If *hTxtFileIn
    If *hTxtFileIn\hMem
      If *hTxtFileIn\Encoding = Encoding
        *hTxtFileIn\hMemPos = *hTxtFileIn\hMem
        xResult = #True
        ElseIf *hTxtFileIn\Encoding = #CP_ACP And Encoding = #CP_UTF8
        xSizeOrg = (*hTxtFileIn\hMemEnd - *hTxtFileIn\hMem) >> 1
        *hMemMB = MemAllocNC(xSizeOrg + 2)
        If *hMemMB
          If WideCharToMultiByte_(0, 0, *hTxtFileIn\hMem, xSizeOrg, *hMemMB, xSizeOrg + 1, 0, 0) = xSizeOrg
            xSizeNew = MultiByteToWideChar_(Encoding, 0, *hMemMB, xSizeOrg, 0, 0)
            If xSizeNew
              xType2\hMem = MemAllocNC(xSizeNew * 2 + 8)
              If xType2\hMem
                xType2\hMemPos = xType2\hMem
                xLong1 = MultiByteToWideChar_(Encoding, 0, *hMemMB, xSizeOrg, xType2\hMem, xSizeNew + 1)
                If xLong1 = xSizeNew
                  xType2\Encoding = Encoding
                  xType2\hMemEnd = xType2\hMem + (xSizeNew << 1)
                  PokeW(xType2\hMemEnd,   13)
                  PokeW(xType2\hMemEnd+2, 10)
                  PokeW(xType2\hMemEnd+4,  0)
                  MemFree(*hTxtFileIn\hMem)
                  MemCopyRTL(*hTxtFileIn, @xType2, SizeOf(TxtFileReadStruct))
                  xResult = #True
                  EndIf
                If Not xResult
                  MemFree(xType2\hMem)
                  EndIf
                EndIf
              EndIf
            EndIf
          MemFree(*hMemMB)
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP