﻿EnableExplicit

LibBuild_Include(GetOptMonitorFromPoint)
LibBuild_Include(GetOptCursorHotSpotOffset)

Procedure WindowToCursorPos(*xWindowSize.POINT, *xType1.POINT)
  Define.i xLong1
  Define.i xCursorPlusX
  Define.i xCursorPlusX2
  Define.i xCursorPlusY
  Define.i xCursorPlusY2
  Define.RECT xType2
  
  GetCursorPos_(*xType1)
  GetOptMonitorFromPoint(*xType1\x, *xType1\y, @xType2)
  GetOptCursorHotSpotOffset(@xCursorPlusX, @xCursorPlusY, @xCursorPlusX2, @xCursorPlusY2)
    
  If *xType1\x + *xWindowSize\x + xCursorPlusX > xType2\Right
    *xType1\x = *xType1\x - *xWindowSize\x - xCursorPlusX2
    If *xType1\x + *xWindowSize\x > xType2\Right
      *xType1\x = xType2\Right - *xWindowSize\x
      EndIf
    Else
    *xType1\x + xCursorPlusX
    EndIf
    
  If *xType1\y + *xWindowSize\y + xCursorPlusY > xType2\Bottom
    *xType1\y = *xType1\y - *xWindowSize\y - xCursorPlusY2
    If *xType1\y + *xWindowSize\y + xCursorPlusY > xType2\Bottom
      *xType1\y = xType2\Bottom - *xWindowSize\y
      EndIf
    Else
    *xType1\y + xCursorPlusY
    EndIf
  If *xType1\x < xType2\Left
    *xType1\x = xType2\Left
    EndIf
  If *xType1\y < xType2\Top
    *xType1\y = xType2\Top
    EndIf
  EndProcedure


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 3
; Folding = -
; EnableUnicode
; EnableXP