EnableExplicit

#Console = 0
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
#ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_WtoA = 1

XIncludeFile "ctSSLayer_Common_FullDLL.pb"

; Copyright (C) 2002-2011 Jan Vorel
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; If you have any questions, suggestions or bug reports about this product,
; contact me: info@ctuser.net; Do not contact me about general B.A.S.I.C.
; language or A.P.I. issues

#FMod_Always_SetCallbacks = #False
#FMod_Always_SySCallbacks = #True

Prototype.f ProtoGetVersion()
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  Prototype.i ProtoMUSICSetPanSeperation(ptrSong.i, Seperation.f)
  Prototype.i ProtoMUSICSetLooping(ptrSong.i, Looping.b)
  CompilerEndIf


CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
  Import "kernel32.lib" 
    CreateFileW.i (*lpFileName, dwDesiredAccess.i, dwShareMode.i, lpSecurityAttributes.i, dwCreationDisposition.i, dwFlagsAndAttributes.i, hTemplateFile.i)
    EndImport 

  CompilerIf #FMod_Always_SySCallbacks
    CompilerElse
    ImportC "msvcrt.lib" 
      _wfopen.i (*filename, mode)
      fopen.i (*filename, *mode) 
      fseek.i (*hstream, offset.i, origin.i)
      ftell.i (*hstream)
      fread.i (*buffer, size.i, count.i, *hstream)
      fclose.i (*hstream)
      EndImport 
    CompilerEndIf
  CompilerEndIf

ProcedureDLL AttachProcess(Instance)
  CompilerIf #Console
    OpenConsole()
    CompilerEndIf
    

  Global InfoString.s
  CompilerIf #ctSSLayer_CompiledFeature_NoNeedUnicodeConversion_AtoW = 0
    Global InfoStringW.i
    CompilerEndIf
  
  Global *FmodDLL
  Global xSystem.i
  
  #OutPutListMax = 32
  Global OutPutListCount.i
  Global Dim OutPutListDev.i(#OutPutListMax)
  Global Dim OutPutList.s(#OutPutListMax)
  
  
  
  
  Structure ctSSSongInfoStruct
    FormatOK.l ;bool
    Format_Frequency.l
    Format_BitRate.l
    Format_Channels.l
    Format_VBR.l ;bool
    Format_QualityMulti.l
    TagOK.l ;bool
    Tag_Year.l
    Tag_TrackID.l
    Tag_Artist.i
    Tag_Title.i
    Tag_Album.i
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    IR_Name.i
    IR_URL.i
CompilerEndIf
    EndStructure
  
  
  #KeepAliveTime = 1000
  #ctSSLayer_MaxIDs = 16
  #ctSSLayer_MaxIDsX = #ctSSLayer_MaxIDs - 1
  
  
  Global VersionID.i
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global xUseCDDA.i
    Global xUseJitter.i
    Global IsCDing.i
    CompilerEndIf
  Global xNoDirectX.i

  Global WMAUsable.i

  
  Structure tSong
    mode.i
    Pointer.i
    ExtraA.i ;channel or driveletter
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      CDTrackID.i
      CompilerEndIf
    Size.i
    CompilerIf #ctSSLayer_CompiledFeature_ReadTags
      Format_QualityMulti.f
      CompilerEndIf
    CurVolume.i
    IsPaused.i
    LastPosition.i
    CurLoop.i
    CurPan.i
;CompilerIf #ctSSLayer_CompiledFeature_InetStreams
;    IsINet.i
;CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_SetLoops
    LoopStart.i
    LoopEnd.i
    LoopCount.i
CompilerEndIf
    BlockWait.i
CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
    ptrMem.i
    Filename.b[514]
CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
    FilenameIsUnicode.b
CompilerEndIf
CompilerEndIf
    EndStructure

  Global *MemStrConv
  *MemStrConv = AllocateMemory(1024)
  Global xSysPath.s
  CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
      Global *FMUSIC_LoadSongEx
      CompilerEndIf
    Global *FMUSIC_LoadSong
    Global *FMUSIC_GetNumOrders
    Global *FMUSIC_StopSong
    Global *FMUSIC_FreeSong
    Global *FMUSIC_GetOrder
    ;Global *FMUSIC_GetTime
    Global *FMUSIC_IsFinished
    Global *FMUSIC_PlaySong
    Global *FMUSIC_SetMasterVolume
    Global *FMUSIC_SetPaused
    Global *FMUSIC_SetOrder
    CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_LoadSongW And #FMod_Always_SetCallbacks
    Global *FSOUND_File_SetCallbacks
    CompilerEndIf


  Global *FSOUND_Stream_Open
  Global *FSOUND_Stream_GetLengthMs
  Global *FSOUND_Stream_GetOpenState
  Global *FSOUND_Stream_SetSubStream
  Global *FSOUND_Stream_Close
  Global *FSOUND_Stream_PlayEx
  Global *FSOUND_SetVolume
  Global *FSOUND_SetPaused
  Global *FSOUND_Stream_SetTime
  Global *FSOUND_Stream_Stop
  Global *FSOUND_StopSound
  Global *FSOUND_Stream_GetTime
  CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    Global *FSOUND_DSP_GetSpectrum
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    Global *FSOUND_Stream_GetSample
    Global *FSOUND_Sample_GetDefaults
    Global *FSOUND_Sample_GetMode
    Global *FSOUND_Stream_GetLength
    Global *FSOUND_Stream_GetNumTagFields
    Global *FSOUND_Stream_GetTagField
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Global *FSOUND_CD_SetVolume
    Global *FSOUND_CD_GetTrackLength
    Global *FSOUND_CD_Play
    Global *FSOUND_CD_SetPlayMode
    Global *FSOUND_CD_SetTrackTime
    Global *FSOUND_CD_SetPaused
    Global *FSOUND_CD_Stop
    Global *FSOUND_CD_GetTrackTime
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Global *FSOUND_Stream_Net_GetStatus
    CompilerEndIf
  
  CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
    Global xCallHWnd.i
    Global xCallMsg.i
    Global xCallParam.i
    Global *FSOUND_Stream_SetEndCallback
    CompilerEndIf
  
  DataSection
rbW:
    Data.b $72, $00, $62, $00, $00, $00
rbA:
    Data.b $72, $62, $00
    EndDataSection
  EndProcedure

XIncludeFile "ctSSLayer_Common01.pb"
XIncludeFile "ctSSLayer_Common_Debugger.pb"
XIncludeFile "ctSSLayer_Common_GetTrackNumber.pb"

Procedure GetFuncs()
  CompilerIf #ctSSLayer_CompiledFeature_LoadSongW And #FMod_Always_SetCallbacks
    *FSOUND_File_SetCallbacks = GetFunction(*FmodDLL, "_FSOUND_File_SetCallbacks@20")
    CompilerEndIf
  *FSOUND_SetVolume = GetFunction(*FmodDLL, "_FSOUND_SetVolume@8")
  *FSOUND_SetPaused = GetFunction(*FmodDLL, "_FSOUND_SetPaused@8")
  *FSOUND_Stream_SetTime = GetFunction(*FmodDLL, "_FSOUND_Stream_SetTime@8")
  *FSOUND_Stream_Stop = GetFunction(*FmodDLL, "_FSOUND_Stream_Stop@4")
  *FSOUND_StopSound = GetFunction(*FmodDLL, "_FSOUND_StopSound@4")
  *FSOUND_Stream_GetTime = GetFunction(*FmodDLL, "_FSOUND_Stream_GetTime@4")
  *FSOUND_Stream_GetLengthMs = GetFunction(*FmodDLL, "_FSOUND_Stream_GetLengthMs@4")
  *FSOUND_Stream_GetOpenState = GetFunction(*FmodDLL, "_FSOUND_Stream_GetOpenState@4")
  *FSOUND_Stream_SetSubStream = GetFunction(*FmodDLL, "_FSOUND_Stream_SetSubStream@8")
  *FSOUND_Stream_Close = GetFunction(*FmodDLL, "_FSOUND_Stream_Close@4")
  CompilerIf #ctSSLayer_CompiledFeature_ReadTags
    *FSOUND_Stream_GetSample = GetFunction(*FmodDLL, "_FSOUND_Stream_GetSample@4")
    *FSOUND_Sample_GetDefaults = GetFunction(*FmodDLL, "_FSOUND_Sample_GetDefaults@20")
    *FSOUND_Sample_GetMode = GetFunction(*FmodDLL, "_FSOUND_Sample_GetMode@4")
    *FSOUND_Stream_GetLength = GetFunction(*FmodDLL, "_FSOUND_Stream_GetLength@4")
    CompilerEndIf
  CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    *FMUSIC_SetMasterVolume = GetFunction(*FmodDLL, "_FMUSIC_SetMasterVolume@8")
    *FMUSIC_PlaySong = GetFunction(*FmodDLL, "_FMUSIC_PlaySong@4")
    *FMUSIC_SetPaused = GetFunction(*FmodDLL, "_FMUSIC_SetPaused@8")
    *FMUSIC_SetOrder = GetFunction(*FmodDLL, "_FMUSIC_SetOrder@8")
    *FMUSIC_StopSong = GetFunction(*FmodDLL, "_FMUSIC_StopSong@4")
    *FMUSIC_GetOrder = GetFunction(*FmodDLL, "_FMUSIC_GetOrder@4")
    *FMUSIC_FreeSong = GetFunction(*FmodDLL, "_FMUSIC_FreeSong@4")
    ;*FMUSIC_GetTime = GetFunction(*FmodDLL, "_FMUSIC_GetTime@4")
    Global *FMUSIC_IsFinished = GetFunction(*FmodDLL, "_FMUSIC_IsFinished@4")
    CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
      If VersionID > 36999
        *FMUSIC_LoadSongEx = GetFunction(*FmodDLL, "_FMUSIC_LoadSongEx@24")
        ElseIf VersionID > 36199
        *FMUSIC_LoadSongEx = GetFunction(*FmodDLL, "_FMUSIC_LoadSongEx@20")
        Else
        *FMUSIC_LoadSongEx = GetFunction(*FmodDLL, "_FMUSIC_LoadSongMemory@8")
        EndIf
      CompilerEndIf
    *FMUSIC_LoadSong = GetFunction(*FmodDLL, "_FMUSIC_LoadSong@4")

    *FMUSIC_GetNumOrders = GetFunction(*FmodDLL, "_FMUSIC_GetNumOrders@4")
    Global MUSICSetPanSeperation.ProtoMUSICSetPanSeperation = GetFunction(*FmodDLL, "_FMUSIC_SetPanSeperation@8")
    CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    If VersionID > 33999
      Global *FSOUND_DSP_GetSpectrum = GetFunction(*FmodDLL, "_FSOUND_DSP_GetSpectrum@0")
      EndIf
    CompilerEndIf
  If VersionID < 35000
    *FSOUND_Stream_PlayEx = GetFunction(*FmodDLL, "_FSOUND_Stream_Play@8")
    Else
    *FSOUND_Stream_PlayEx = GetFunction(*FmodDLL, "_FSOUND_Stream_PlayEx@16")
    EndIf
  If VersionID > 35999
    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      *FSOUND_CD_GetTrackLength = GetFunction(*FmodDLL, "_FSOUND_CD_GetTrackLength@8")
      *FSOUND_CD_SetVolume = GetFunction(*FmodDLL, "_FSOUND_CD_SetVolume@8")
      *FSOUND_CD_Play = GetFunction(*FmodDLL, "_FSOUND_CD_Play@8")
      *FSOUND_CD_SetPlayMode = GetFunction(*FmodDLL, "_FSOUND_CD_SetPlayMode@8")
      *FSOUND_CD_SetPaused = GetFunction(*FmodDLL, "_FSOUND_CD_SetPaused@8")
      *FSOUND_CD_Stop = GetFunction(*FmodDLL, "_FSOUND_CD_Stop@4")
      *FSOUND_CD_GetTrackTime = GetFunction(*FmodDLL, "_FSOUND_CD_GetTrackTime@4")
      CompilerEndIf
    CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Global MUSICSetLooping.ProtoMUSICSetLooping = GetFunction(*FmodDLL, "_FMUSIC_SetLooping@8")
      CompilerEndIf


    CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA | #ctSSLayer_CompiledFeature_ReadTags
      If VersionID > 36100
        CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
          *FSOUND_CD_SetTrackTime = GetFunction(*FmodDLL, "_FSOUND_CD_SetTrackTime@8")
          CompilerEndIf
        CompilerIf #ctSSLayer_CompiledFeature_ReadTags
          If Not VersionID < 37100
            *FSOUND_Stream_GetTagField = GetFunction(*FmodDLL, "_FSOUND_Stream_GetTagField@24")
            *FSOUND_Stream_GetNumTagFields = GetFunction(*FmodDLL, "_FSOUND_Stream_GetNumTagFields@8")
            EndIf
          CompilerEndIf
        EndIf
      CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Else
      *FSOUND_CD_GetTrackLength = GetFunction(*FmodDLL, "_FSOUND_CD_GetTrackLength@4")
      *FSOUND_CD_SetVolume = GetFunction(*FmodDLL, "_FSOUND_CD_SetVolume@4")
      *FSOUND_CD_Play = GetFunction(*FmodDLL, "_FSOUND_CD_Play@4")
      *FSOUND_CD_SetPlayMode = GetFunction(*FmodDLL, "_FSOUND_CD_SetPlayMode@4")
      *FSOUND_CD_SetPaused = GetFunction(*FmodDLL, "_FSOUND_CD_SetPaused@4")
      *FSOUND_CD_Stop = GetFunction(*FmodDLL, "_FSOUND_CD_Stop@0")
      *FSOUND_CD_GetTrackTime = GetFunction(*FmodDLL, "_FSOUND_CD_GetTrackTime@0")
CompilerEndIf
    EndIf
  If VersionID < 37000
    *FSOUND_Stream_Open = GetFunction(*FmodDLL, "_FSOUND_Stream_OpenFile@12")
    Else
    *FSOUND_Stream_Open = GetFunction(*FmodDLL, "_FSOUND_Stream_Open@16")
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    *FSOUND_Stream_Net_GetStatus = GetFunction(*FmodDLL, "_FSOUND_Stream_Net_GetStatus@20")
CompilerEndIf
    EndIf

  CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
    If VersionID > 32999
      *FSOUND_Stream_SetEndCallback = GetFunction(*FmodDLL, "_FSOUND_Stream_SetEndCallback@12")
      EndIf
    CompilerEndIf
  
  CompilerIf #ctSSLayer_CompiledFeature_SetLoops
    If VersionID > 36099
      *FSOUND_Stream_SetLoopPoints = GetFunction(*FmodDLL, "_FSOUND_Stream_SetLoopPoints@12")
      If VersionID > 36299
        *FSOUND_Stream_SetLoopCount = GetFunction(*FmodDLL, "_FSOUND_Stream_SetLoopCount@8")
        EndIf
      EndIf
;    *FSOUND_SetLoopMode = GetFunction(*FmodDLL, "_FSOUND_SetLoopMode@8")
    CompilerEndIf
  EndProcedure

ProcedureDLL DetachProcess(Instance)
  CompilerIf #Console
    CloseConsole()
    CompilerEndIf
  If *FmodDLL
    If xSystem
      CallFunction(*FmodDLL, "_FSOUND_Close@0")
      EndIf
    CloseLibrary(*FmodDLL)
    EndIf
  EndProcedure

ProcedureDLL AttachThread(Instance)
  EndProcedure

ProcedureDLL DetachThread(Instance)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
Procedure.s HexMe(Value.l)
  Define.s xResult = Space(8)
  Define.i xPtr
  xPtr = @xResult

  EnableASM
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    MOV rax, xPtr
    MOV edx, Value
    MOV ch, $8
   !hexitloop:
    ROL edx, 4
    MOV cl, dl
    !AND cl, $f
    CMP cl, $a
   !JB hexit_numeric
    ADD cl, $7
   !hexit_numeric:
    ADD cl, $30
    MOV [rax], byte cl
    INC rax
    DEC ch
   !JNZ hexitloop
    CompilerElse
    MOV eax, xPtr
    MOV edx, Value
    MOV ch, $8
   !hexitloop:
    ROL edx, 4
    MOV cl, dl
    !AND cl, $f
    CMP cl, $a
   !JB hexit_numeric
    ADD cl, $7
   !hexit_numeric:
    ADD cl, $30
    MOV [eax], byte cl
    INC eax
    DEC ch
   !JNZ hexitloop
    CompilerEndIf
  DisableASM
  ProcedureReturn xResult
  EndProcedure

Procedure.i HexUn(*ptrStr)
  EnableASM
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    MOV rdx, *ptrStr     ;address
   !XOR rax, rax         ;value
    MOV ch, $8
   !hexunloop:
    ROL eax, 4
    MOV byte cl, [rdx]
    SUB cl, $30
    CMP cl, $11
   !JB hexun_numeric
    SUB cl, $7
   !hexun_numeric:
    ADD al, cl
    INC rdx
    DEC ch
   !JNZ hexunloop
    mov *ptrStr, rax
    CompilerElse
    MOV edx, *ptrStr     ;address
   !XOR eax, eax         ;value
    MOV ch, $8
   !hexunloop:
    ROL eax, 4
    MOV byte cl, [edx]
    SUB cl, $30
    CMP cl, $11
   !JB hexun_numeric
    SUB cl, $7
   !hexun_numeric:
    ADD al, cl
    INC edx
    DEC ch
   !JNZ hexunloop
    mov *ptrStr, eax
    CompilerEndIf
  DisableASM
  ProcedureReturn *ptrStr
  EndProcedure

  Procedure.s MkFakeFilename(FilenameAnsi.s, *ptr)
    Define.i xLong1
    Define.s xChar1
    
    If Len(FilenameAnsi) > 2
      If FindString(FilenameAnsi, ".", 1)
        xChar1 = FilenameAnsi
        Repeat
          xLong1 = FindString(xChar1, ".", 1)
          If xLong1 = 0
            Break
            EndIf
          xChar1 = Mid(xChar1, xLong1 + 1)
          ForEver
        ProcedureReturn "ctsslayer://" + HexMe(*ptr) + "." + xChar1
        EndIf
      EndIf
    EndProcedure

  Procedure.i UnFakeFilename(FilenameAnsi.s)
    Define.i xLong1
    
    If Left(FilenameAnsi, 12) = "ctsslayer://"
      FilenameAnsi = Mid(FilenameAnsi, 13)
      If Len(FilenameAnsi) > 9
        If Mid(FilenameAnsi, 9, 1) = "."
          ProcedureReturn HexUn(@FilenameAnsi)
          EndIf
        EndIf
      EndIf
    EndProcedure

  Procedure.i useropen(*ptrFakeFilename)
    Define *ptrFilename.tSong = UnFakeFilename(PeekS(*ptrFakeFilename))
    Define.i Result
;Debug("UserOpen")
;Debug "Mem: " + Hex(*ptrFilename)
    If *ptrFilename.tSong
;Debug "OrgStr: " + PeekS(*ptrFilename)
  ;Debug "StoredStr: " + PeekS(*ptrFilename\Filename[0])
      CompilerIf #FMod_Always_SySCallbacks
        ;Define.i Result
  
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
          If *ptrFilename\FilenameIsUnicode
            Result = CreateFileW(@*ptrFilename\Filename[0], $80000000, $1, $0, $3, $20, $0)
            Else
            Result = CreateFile_(@*ptrFilename\Filename[0], $80000000, $1, $0, $3, $20, $0)
            EndIf
          CompilerElse
          Result = CreateFileW(@*ptrFilename\Filename[0], $80000000, $1, $0, $3, $20, $0)
          CompilerEndIf
        If Result = -1
          ProcedureReturn 0
          ElseIf result = 0
          ProcedureReturn -1
          Else
          ProcedureReturn Result
          EndIf
;Debug("UserOpen0 - " + PeekS(@*ptrFilename\Filename[0]))
        CompilerElse
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
          If *ptrFilename\FilenameIsUnicode
            ProcedureReturn _wfopen(@*ptrFilename\Filename[0], ?rbW)
            Else
            ProcedureReturn fopen(@*ptrFilename\Filename[0], @"rb")
            EndIf
          CompilerElse
          ProcedureReturn _wfopen(@*ptrFilename\Filename[0], ?rbA)
          CompilerEndIf
        CompilerEndIf
      EndIf
    EndProcedure

  CompilerIf #FMod_Always_SySCallbacks
    Procedure.i userclose(*hstream)
;Debug("UserClose")
      If *hstream = -1
        *hstream = 0
        ElseIf *hstream = 0
        *hstream -1
        EndIf
      
      CloseHandle_(*hstream)
      EndProcedure
    CompilerElse
    Procedure.i userclose(*hstream)
;Debug("UserClose")
      fclose(*hstream)
      EndProcedure
    CompilerEndIf

  CompilerIf #FMod_Always_SySCallbacks
    Procedure.i userread(*buffer, size.i, *hstream.tSong)
;Debug "UserRead"
      Define.i Result

      If *hstream = -1
        *hstream = 0
        ElseIf *hstream = 0
        *hstream -1
        EndIf

      If ReadFile_(*hstream, *buffer, size, @Result, 0)
        ProcedureReturn Result
        EndIf
      ProcedureReturn 0
      EndProcedure
    CompilerElse
    Procedure.i userread(*buffer, size.i, *hstream)
;Debug "UserRead"
      ProcedureReturn fread(*buffer, 1, size, *hstream)
      EndProcedure
    CompilerEndIf

  CompilerIf #FMod_Always_SySCallbacks
    Procedure.i userseek(*hstream.tSong, pos.i, mode.i)
;Debug "UserSeek"

      If *hstream = -1
        *hstream = 0
        ElseIf *hstream = 0
        *hstream -1
        EndIf

      If SetFilePointer_(*hstream, pos, 0, mode) & $80000000
        ProcedureReturn 1
        EndIf
      ProcedureReturn 0
      EndProcedure
    CompilerElse
    Procedure.i userseek(*hstream, pos.i, mode.i)
;Debug "UserSeek"
      ProcedureReturn fseek(*hstream, pos, mode)
      EndProcedure
    CompilerEndIf

  CompilerIf #FMod_Always_SySCallbacks
    Procedure.i usertell(*hstream.tSong)
;Debug "UserTell"

      If *hstream = -1
        *hstream = 0
        ElseIf *hstream = 0
        *hstream -1
        EndIf

      Define.i Result = SetFilePointer_(*hstream, 0, 0, #FILE_CURRENT)
      If (Result & $80000000)
        ProcedureReturn -1
        EndIf
      ProcedureReturn Result
      EndProcedure
    CompilerElse
    Procedure.i usertell(*hstream)
;Debug "UserTell"
      ProcedureReturn ftell(*hstream)
      EndProcedure
    CompilerEndIf


  ProcedureC.i useropenc(*ptrFilename)
    ProcedureReturn useropen(*ptrFilename)
    EndProcedure

  ProcedureC.i userclosec(*hstream)
    ProcedureReturn userclose(*hstream)
    EndProcedure

  ProcedureC.i userreadc(*buffer, size.i, *hstream)
    ProcedureReturn userread(*buffer, size, *hstream)
    EndProcedure
;
  ProcedureC.i userseekc(*hstream, pos.i, mode.i)
    ProcedureReturn userseek(*hstream, pos, mode)
    EndProcedure

  ProcedureC.i usertellc(*hstream)
    ProcedureReturn usertell(*hstream)
    EndProcedure
  CompilerEndIf


ProcedureDLL.i ctSSLayer_CanUseItem(Index.i)
  Define.i Result

  Select Index
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case 0 ; cdda   (force off / force on / user choses)
      ;Result = (VersionID >= CDDAVersion)
      ;37100
      If VersionID > 37099
        Result = 2
        EndIf
    Case 1 ; jitter   (force off / force on / user choses)
      ;Result = (VersionID >= CDDAVersion)
      If VersionID > 37099
        Result = 2
        EndIf
    Case 2 ; runtimecdda/jitter update   (disabled=requires ReInit of soundsystem / available)
      Result = 1
CompilerEndIf
    Case 3 ; checkaccuratestreams   (force off / force on / user choses)
      Result = 2
    
CompilerIf #ctSSLayer_CompiledFeature_Spectrum
    Case 4 ; UseSpectrum   (disabled / 1=mono / 2=stereo)
      ;Result = VersionID >= 34000
      If VersionID > 33999
        Result = 1
        EndIf
CompilerEndIf
    ;Case 5 ; UseGetCDDtracks   (disabled / available)
    ;  ;Result = VersionID > 35999
    ;  If VersionID > 35999
    ;    Result = 1
    ;    EndIf
    Case 6 ; ModuleTimeHandling:             ;getp/Len (For seeking!!)
      ; 1 = Patterns (or patterncheck needed) (pat/pat)
      ; 2 = Elapsed time (only; )             (0/0) - disabled
      ; 4 = Real times                        (tim/tim)
      ;     getpattern stuff if also needs pattern checking!
      ; 8 = cangettotalsize                   (pat!/pat!), musictime=totaltime
      
      Result = 1;3
    Case 7 ; maxDeviceCount
      Result = OutPutListCount
    ;Case 9 ; MidiXFade   (disabled / available)
      ;Result = 0
    
    
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case $A ; SupportsCD or CDDA (0/1)
      Result = 1
CompilerEndIf
    Case $C ; KeepAliveTime: leave channel stopped before unloading (buffer!)
      Result = #KeepAliveTime
    Case $D      ;#ctSSLayer_MaxIDs ; for future use, currently fixed
      Result = #ctSSLayer_MaxIDs
CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
    ;Case $E
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
    Case $10 ; EndCallback; 1 = partial, 2 = full
      If VersionID > 32999 ;37499
        Result = 1
        EndIf
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case $11 ; Internet/streams; 1 = yes!
      If VersionID > 36999
        Result = 1
        EndIf
CompilerEndIf
    Case $12 ; NonBlocking supported    (force off / force on / user choses)
      If VersionID > 35999
        Result = 2
        EndIf
;    Case $18 ; Midi soundfonts...
;    Case $19 ; Midi soundfonts runtime updateable...
;    Case $1A ; maxSoundFontCount
    Case $20
      ;    10 = should update
      ;    11 = untested
      ;    12 = new & untested
      ;    13 = hasrestrictions, up/downgrade

      ;  < 20 = ok

      ;    20 (DirectX missing)
      ;    21 (DirectX to old (or missing))
      ;    30 = to old
      ;    31 = incompatible
      ;    32 = to new
      ;    90 = cannot load (generic something missing)
      ;         should have high priority!

;PrintN(Str(VersionID))

      Select VersionID
        Case -2
          Result = 32
        Case -1, 0
          Result = 90

;specific
        Case 37000
          Result = 31

;mainvers
;minvers
        Case 0 To 32999
          Result = 30
        Case 36000, 36100
          Result = 13
        Case 0 To 36999
          Result = 10
        Case 0 To 37199
          Result = 13
        Case 0 To 37599
          Result = 0
        Case 0 To 37999
          Result = 12
        Case 0 To $ffffffff
          Result = 32
        EndSelect
;PrintN(Str(Result))
    EndSelect

  
  ProcedureReturn Result
  EndProcedure

ProcedureDLL ctSSLayer_Close(Fast.i)
  If Fast = 0
    Sleep_(#KeepAliveTime + 500)
    EndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    If IsCDing
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, IsCDing, 0)
        CallFunctionFast(*FSOUND_CD_Stop, IsCDing)
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, 0)
        CallFunctionFast(*FSOUND_CD_Stop)
        EndIf
      EndIf
    CompilerEndIf  
  CallFunction(*FmodDLL, "_FSOUND_Close@0")
  *Debugger = 0
  xSystem = 0

  ;DoClearError()
  EndProcedure

ProcedureDLL.i ctSSLayer_DllRelease()
  If *FmodDLL
    CloseLibrary(*FmodDLL)
    *FmodDLL = 0
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA
  ProcedureDLL.i ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerElse
  Procedure.i ctSSLayer_GetDeviceFromSSLIDA(*SSLID)
  CompilerEndIf
    Define.i Result
    Define.s xChar1

    Result = -1
    If *SSLID
      xChar1 = LCase(PeekS(*SSLID))
      If Left(xChar1, 5) = "fmod_"
        Result = Val(Mid(xChar1, 6))
        If Result < 0 Or Result >= OutPutListCount
          Result = -1
          EndIf
        EndIf
      EndIf
    ProcedureReturn Result

    CompilerIf #ctSSLayer_CompiledFeature_GetDeviceFromSSLIDA = 1
    EndProcedure
    CompilerElse
    EndProcedure
    CompilerEndIf
  CompilerEndIf
CompilerIf 0
  ProcedureDLL.i ctSSLayer_GetDeviceFromSSLIDW(*SSLID)
    EndProcedure
  CompilerEndIf
XIncludeFile "ctSSLayer_Common_GetDeviceFromSSLIDW.pb"

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLID
  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
  ProcedureDLL.i ctSSLayer_GetDeviceSSLIDA(DeviceID.i)
  CompilerElse
  Procedure.i ctSSLayer_GetDeviceSSLIDA(DeviceID.i)
  CompilerEndIf
    
    If DeviceID >= 0 And DeviceID < OutPutListCount
      InfoString = "fmod_" + Str(DeviceID)
      ProcedureReturn @InfoString
      EndIf

  CompilerIf #ctSSLayer_CompiledFeature_GetDeviceSSLIDA
    EndProcedure
  CompilerElse
    EndProcedure
  CompilerEndIf
  CompilerEndIf

CompilerIf 0
  ProcedureDLL.i ctSSLayer_GetDeviceSSLIDW(DeviceID.i)
    EndProcedure
  CompilerEndIf
XIncludeFile "ctSSLayer_Common_GetDeviceSSLIDW.pb"

CompilerIf #ctSSLayer_CompiledFeature_GetDeviceNameA
  ProcedureDLL.i ctSSLayer_GetDeviceNameA(DeviceID.i, *Flags)
    If DeviceID >= 0 And DeviceID < OutPutListCount
      If *Flags: PokeI(*Flags, OutputListDev(DeviceID)): EndIf
      InfoString = OutPutList(DeviceID)
      ProcedureReturn @InfoString
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf 0
  ProcedureDLL.i ctSSLayer_GetDeviceNameW(DeviceID, *Flags)
    EndProcedure
  CompilerEndIf
XIncludeFile "ctSSLayer_Common_GetDeviceNameW.pb"

ProcedureDLL.i ctSSLayer_SoundFontGetSize(FontID.i, *ptrQuad)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetCaptionA(FontID.i)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetCaptionW(FontID.i)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetFilenameA(FontID)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetFilenameW(FontID)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontGetCurrent()
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontRefreshList(Flags.i)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontSet(FontID.i)
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontNumAffectedFiles()
  EndProcedure

ProcedureDLL.i ctSSLayer_SoundFontAffectsSpecificSong(*SongPointer.tSong)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA Or #ctSSLayer_CompiledFeature_GetInfoStringW
  IncludeFile "Common_VerQueryValue.pb"
  ;IncludeFile "ctSSLayer_Common_GetFileVersionEx.pb"
  
  Procedure.s GetCopyRightFromFile(Filename.s)
    ;Define.s Result
    Define.s xChar1
    Define.s xChar2
    Define *hMem
    
    *hMem = GetFileVersionInfo(Filename)
    If *hMem
  ;    xChar1 = Trim(GetFileVersionFieldEx(Filename, #GetFileVersionField_CompanyName))
      ;XDebug ("Comments", *hMem, #GetFileVersionField_Comments)
      ;XDebug ("CompanyName", *hMem, #GetFileVersionField_CompanyName)
      ;XDebug ("FileDesc", *hMem, #GetFileVersionField_FileDesc)
      ;XDebug ("InternalName", *hMem, #GetFileVersionField_InternalName)
      ;XDebug ("LegalCopyright", *hMem, #GetFileVersionField_LegalCopyright)
      
      xChar1 = Trim(VerQueryValue(*hMem, #GetFileVersionField_LegalCopyright))
      If Left(xChar1, 10) = "Copyright "
        xChar1 = LTrim(Mid(xChar1, 11))
        EndIf
      If Left(xChar1, 1) = Chr(169)
        xChar1 = LTrim(Mid(xChar1, 2))
        EndIf
      ;If Right(xChar1, 20) = "Un4seen Developments"
      ;  xChar1 = xChar1 + " Ltd. All rights reserved."
      ;  EndIf
      ;If Right(xChar1, 8) = "MaresWEB"
      ;  xChar1 = xChar1 + " (http://www.maresweb.de). All rights reserved"
      ;  EndIf
      If Len(xChar1) < 12
        xChar2 = Trim(VerQueryValue(*hMem, #GetFileVersionField_CompanyName))
        If xChar2
          ;If xChar2 = "Un4seen Developments"
          ;  xChar2 = xChar2 + " Ltd. All rights reserved."
          ;  EndIf
          ;If xChar2 = "MaresWEB"
          ;  xChar2 = xChar2 + " (http://www.maresweb.de). All rights reserved"
          ;  EndIf
          If xChar1
            xChar1 = xChar1 + ", " + xChar2
            Else
            xChar1 = xChar2
            EndIf
          EndIf
        EndIf
  
      If xChar1
        ;Debug Caption + " / " + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2) + ": " + xChar1
        xChar1 = "Copyright " + xChar1
        EndIf
      
      xChar2 = Trim(VerQueryValue(*hMem, #GetFileVersionField_FileVersion))
      If Left(xChar1, 8) = "Version "
        xChar2 = LTrim(Mid(xChar2, 9))
        EndIf
      ;If Not xChar2
      ;  Define.i xLong1
      ;  Define.i xLong2 = GetFileVersionEx(Filename, @xLong1)
      ;  Debug Hex(xLong2) + " / " + Hex(xLong1)
      ;  EndIf
      If xChar2
        If xChar1
          xChar1 = "Version " + xChar2 + "; " + xChar1
          Else
          xChar1 = "Version " + xChar2
          EndIf
        EndIf
      
      ;If xChar1
       ; ;Debug Caption + " / " + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2) + ": " + xChar1
       ; ;Debug xChar1
       ; ;Else
       ; ;Debug "********* Fail Copyright *****************************" + Mid(Filename, Len(Filename) - FindString(ReverseString(Filename), "\", 1) + 2)
       ; EndIf
  
      ;XDebug ("LegalTrademarks", *hMem, #GetFileVersionField_LegalTrademarks)
      ;XDebug ("OriginalFilename", *hMem, #GetFileVersionField_OriginalFilename)
      ;XDebug ("PrivateBuild", *hMem, #GetFileVersionField_PrivateBuild)
      ;XDebug ("ProductName", *hMem, #GetFileVersionField_ProductName)
  ;  XDebug ("ProductVersion", *hMem, #GetFileVersionField_ProductVersion)
      ;XDebug ("SpecialBuild", *hMem, #GetFileVersionField_SpecialBuild)
      
      FreeFileVersionInfo(*hMem)
      ProcedureReturn xChar1
      EndIf
    EndProcedure
  
  Procedure GetPluginCPI(Caption.s, *hDLL, Filename.s, ExtraInfo.s)
    ;Global HasPI
    If *hDLL
      Filename = GetCopyRightFromFile(Filename)
      If Filename
        Filename = " " + Filename
        EndIf
      InfoString = Caption + Filename + ExtraInfo
      ;HasPI = 1
      ;Debug Caption + Filename + ExtraInfo
      EndIf
    EndProcedure

  CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA
  ProcedureDLL.i ctSSLayer_GetInfoStringA(Index.i)
  CompilerElse
  Procedure.i ctSSLayer_GetInfoStringA(Index.i)
  CompilerEndIf
    InfoString = ""
    
    Select Index
      Case 0 ; ShortName
        InfoString = "FMOD"
      Case 1 ; FullName
        InfoString = "FMOD Sound System by Firelight Technologies"
      Case 2 ; DllName
        CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
          InfoString = "FMOD64.dll"
          CompilerElse
          InfoString = "FMOD.dll"
          CompilerEndIf
  ;    Case 3 ; Short Version byfix
  ;      InfoString = "fmod"
      Case 4 ; Unique dll/versions string
        InfoString = "fmod3_" + Trim(Str(VersionID))
      ;Case $A ; Full plugin copyright info
      Case $5 ; Full copyright, info etc
        InfoString = ""
        CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
          GetPluginCPI("FMOD Soundsystem", *FmodDLL, "fmod64.dll", "")
          CompilerElse
          GetPluginCPI("FMOD Soundsystem", *FmodDLL, "fmod.dll", "")
          CompilerEndIf
      ;Case $A ; Full plugin copyright info
      Case $B; trademarks
        InfoString = "FMOD is a registered trademark of Firelight Technologies Pty Ltd."

  
  
      Case $10 ; StreamsAll
        If VersionID < 34000
          InfoString = "mp3;wav;"
          ElseIf VersionID < 36000
          InfoString = "ogg;mp3;wav;aiff;"
          Else
          InfoString = "ogg;mp2,mp3;wav;aiff;"
          EndIf
        If WMAUsable
          InfoString = InfoString + "wma,asf;"
          EndIf
  CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case $11 ; TrackerAllbutMidi
        If VersionID < 36100
          InfoString = "mod,it,xm,s3m;"
          Else
          InfoString = "mod,it,xm,s3m;oxm;"
          EndIf
      Case $12 ; Midi
        InfoString = "mid,midi;rmi,sgt;"
  CompilerEndIf
      Case $19 ; AllDef
        If VersionID < 34000
          InfoString = "mp3;"
          Else
          InfoString = "ogg;mp2,mp3;"
          EndIf
  
      Case $30
        If VersionID > 0
          Define.i xLong1
          xLong1 = VersionID % 10000
          InfoString = Str(Int(VersionID / 10000)) + "." + Right("0" + Str(Int((xLong1) / 100)), 2)
          ;InfoString = Str(Int(VersionID / 10000)) + "." + Right("0" + Str((VersionID % ff00) >> 8), 2)
          ;InfoString = Str((VersionID % $ffff0000) >> 16) + "." + Right("0" + Str((VersionID % $ff00) >> 8), 2)
          Else
          InfoString = ""
          ProcedureReturn 0
          EndIf
      Case $31 ; required dll files; seperate with ;!
        CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
          InfoString = "fmod64.dll"
          CompilerElse
          InfoString = "fmod.dll;msvcrt.dll"
          CompilerEndIf
      Case $40 ; homepage URL
        InfoString = "http://www.fmod.org"
      Case $50
        If VersionID < 37200
          InfoString = "CD audio / multiple drives"
          Else
          InfoString = ""
          ProcedureReturn 0
          EndIf
      Case $51
        If VersionID = 36000 Or VersionID = 36100
          InfoString = "DirectX"
          Else
          InfoString = ""
          ProcedureReturn 0
          EndIf
      Default
        InfoString = ""
        ProcedureReturn 0
      EndSelect
  
    ProcedureReturn @InfoString
  
  CompilerIf #ctSSLayer_CompiledFeature_GetInfoStringA ; for PB IDE folding feature
    EndProcedure                                       ; for PB IDE folding feature
  CompilerElse                                         ; for PB IDE folding feature
    EndProcedure                                       ; for PB IDE folding feature
  CompilerEndIf                                        ; for PB IDE folding feature
  
  CompilerIf 0                                         ; for enlisting in current project, real procedure in common file
    ProcedureDLL.i ctSSLayer_GetInfoStringW(Index.i)   ; for enlisting in current project, real procedure in common file
      EndProcedure                                     ; for enlisting in current project, real procedure in common file
    CompilerEndIf                                      ; for enlisting in current project, real procedure in common file
  XIncludeFile "ctSSLayer_Common_GetInfoStringW.pb"
CompilerEndIf


ProcedureDLL.i ctSSLayer_GetPosition(*SongPointer.tSong)
  Define.i Result

  Select *SongPointer\mode
   
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case #ctSSLayer_MusicTypeInetStream
      Define.i bufferused
      Define.i bitrate
      Define.i flags

      ;If *BitRate = 0
      ;  *BitRate = @bitrate
      ;  EndIf
      If CallFunctionFast(*FSOUND_Stream_Net_GetStatus, *SongPointer\Pointer, @Result, @bufferused, @bitrate, @flags)
        Select Result
          Case 2, 3
            Result = bufferused
          Default
            Result = -1
          EndSelect
        Else
        Result = -1
        EndIf
CompilerEndIf
    Case #ctSSLayer_MusicTypeStream
      Result = CallFunctionFast(*FSOUND_Stream_GetTime, *SongPointer\Pointer)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      If *SongPointer\IsPaused
        Result = *SongPointer\LastPosition
        Else
        Result = CallFunctionFast(*FMUSIC_GetOrder, *SongPointer\Pointer)
        EndIf
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If *SongPointer\IsPaused
        Result = *SongPointer\LastPosition
        ElseIf VersionID > 35999
        Result = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
        Else
        Result = CallFunctionFast(*FSOUND_CD_GetTrackTime)
        EndIf
CompilerEndIf
    EndSelect
  ProcedureReturn Result
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  XIncludeFile "ctSSLayer_Common_MaxF.pb"

  ProcedureDLL ctSSLayer_GetSpectrum(*xSingleA1, ArraySize.i, *SongPointer.tSong, Stereo.i)
    Static xLong1.i
    Static xLong2.i
    Static xLong4.i
    Static xSingle1.f
  
    #xWGS_GetWidth = 511
    #xWGS_GetWidth_ArrayLIDX = #xWGS_GetWidth - 1
    Static Dim xSingleA2.f(#xWGS_GetWidth_ArrayLIDX)



    xLong1 = CallFunctionFast(*FSOUND_DSP_GetSpectrum)
    If xLong1 = 0
      If Stereo = 3
        RtlZeroMemory_(*xSingleA1, ArraySize * 8)
        Else
        RtlZeroMemory_(*xSingleA1, ArraySize * 4)
        EndIf
      Else
      CopyMemory(xLong1 + 4, @xSingleA2(0), #xWGS_GetWidth * 4)
      If ArraySize > #xWGS_GetWidth: ArraySize = #xWGS_GetWidth: EndIf

      For xLong1 = 0 To ArraySize - 1
        xLong2 = xLong1 * #xWGS_GetWidth / ArraySize
        xSingle1 = xSingleA2(xLong2)
        For xLong4 = xLong2 + 1 To (xLong1 + 1) * #xWGS_GetWidth / ArraySize - 1
          xSingle1 = MaxF(xSingle1, xSingleA2(xLong4))
          Next
        xSingleA2(xLong1) = xSingle1 * 0.4
        Next
      CopyMemory(@xSingleA2(0), *xSingleA1, ArraySize * 4)
      If Stereo = 3
        CopyMemory(@xSingleA2(ArraySize), *xSingleA1, ArraySize * 4)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

Procedure CanInitAny()
  If CallFunction(*FmodDLL, "_FSOUND_Init@12", 48000, 256, 2)
    ElseIf CallFunction(*FmodDLL, "_FSOUND_Init@12", 44100, 256, 2)
    ElseIf CallFunction(*FmodDLL, "_FSOUND_Init@12", 32000, 256, 2)
    ElseIf CallFunction(*FmodDLL, "_FSOUND_Init@12", 22050, 256, 2)
    Else
    ProcedureReturn 0
    EndIf
  ProcedureReturn 1
;  ; 44100, 48000, 32000, 22050
  EndProcedure

ProcedureDLL.i ctSSLayer_Init(OutputDeviceID, hWnd.i, UseCDDA.i, UseJitterCorrection.i)
  If OutputDeviceID >= 0 And OutputDeviceID < OutPutListCount
    CompilerIf #ctSSLayer_CompiledFeature_LoadSongW And #FMod_Always_SetCallbacks
      CompilerElse
      If VersionID > 36999 ;37000 ? but that ver is not supported
        CallFunction(*FmodDLL, "_FSOUND_File_SetCallbacks@20", @useropen(), @userclose(), @userread(), @userseek(), @usertell())
        ;Debug CallFunctionfast(*FSOUND_File_SetCallbacks, @useropen(), 0, 0, 0, 0)
        Else
        CallFunction(*FmodDLL, "_FSOUND_File_SetCallbacks@20", @useropenc(), @userclosec(), @userreadc(), @userseekc(), @usertellc())
        ;Debug CallFunctionfast(*FSOUND_File_SetCallbacks, @useropenc(), 0, 0, 0, 0)
        EndIf
      CompilerEndIf
    CallFunction(*FmodDLL, "_FSOUND_SetOutput@4", ((OutputListDev(OutputDeviceID) & $FF00) >> 8) + 1)
    If hWnd
      CallFunction(*FmodDLL, "_FSOUND_SetHWND@4", hWnd)
      EndIf
    CallFunction(*FmodDLL, "_FSOUND_SetDriver@4", (OutputListDev(OutputDeviceID) & $FF))
    CallFunction(*FmodDLL, "_FSOUND_SetBufferSize@4", 400)
    If ctSSLayer_CanUseItem(0)
      xUseCDDA = UseCDDA
      EndIf
    xUseJitter = UseJitterCorrection ; And ctSSLayer_CanUseItem(1)
    If CanInitAny()
      GetFuncs()
      xSystem = 1
      ProcedureReturn 1
      EndIf
    ;DoClearError()
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  Procedure.f GetQualityMultiByFilename(Filename.s)
    Define Result.f

    Select LCase(GetExtensionPart(FileName))
      Case "wav"
        Result = 0.1
      Default
        Result = 1
      EndSelect
    ProcedureReturn Result
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  Procedure.i ReadFileToMemory(*Filename, *size, UnicodeStr.i)
    Define.i hFile
    Define.i xLong1
    Define.i Result1
    Define.i Result2

;Debug "RSTM0 - " + Str(UnicodeStr) + " - " + PeekS(*Filename)
    If UnicodeStr
      hFile = CreateFileW(*Filename, $80000000, $1, $0, $3, $20, $0)
      Else
      hFile = CreateFile_(*Filename, $80000000, $1, $0, $3, $20, $0)
      EndIf
    If Not hFile = -1
;Debug "RSTM1"
      Result2 = GetFileSize_(hFile, 0)
      If Not (Result2 & $80000000)
;Debug "RSTM2"
        Result1 = LocalAlloc_(0, Result2)
        If Result1
;Debug "RSTM3"
          If Not ReadFile_(hFile, Result1, Result2, @xLong1, 0) = 0
;Debug "RSTM4"
            If xLong1 = Result2
;Debug "RSTM5"
              CloseHandle_(hFile)
              PokeI(*size, Result2)
              ProcedureReturn Result1
              EndIf
            EndIf
          LocalFree_(Result1)
          EndIf
        EndIf
      CloseHandle_(hFile)
      EndIf
    ProcedureReturn 0
    EndProcedure
  CompilerEndIf



CompilerIf #ctSSLayer_CompiledFeature_LoadSongA And #ctSSLayer_CompiledFeature_LoadSongW
Procedure.i ctSSLayer_LoadSong(mode.i, *Filename, Flags.i, UnicodeStr.i)
CompilerElse
Procedure.i ctSSLayer_LoadSong(mode.i, *Filename, Flags.i)
CompilerEndIf

  CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
    Define.i size
    CompilerEndIf

  Define.i FlagsNew
  Define *SongPointer.tSong = AllocateMemory(SizeOf(tSong))
  Define.s FilenameAnsi
  Define.i xLong1
  
  If *SongPointer
    ;*SongPointer\ptrMem = 0
    CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
      If UnicodeStr
        FilenameAnsi = PeekS(*Filename, -1, #PB_Unicode)
        Else
        FilenameAnsi = PeekS(*Filename)
        EndIf

      xLong1 = Len(FilenameAnsi)
      If xLong1 > 256: Goto FileNameToLong: EndIf
      If UnicodeStr
        RtlMoveMemory_(@*SongPointer\Filename[0], *Filename, xLong1 * 2 + 2)
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
          *SongPointer\FilenameIsUnicode = 1
          CompilerEndIf
        Else
        RtlMoveMemory_(@*SongPointer\Filename[0], *Filename, xLong1 + 1)
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
          *SongPointer\FilenameIsUnicode = 0
          CompilerEndIf
        EndIf
      CompilerElse
      FilenameAnsi = PeekS(*Filename)
      CompilerEndIf





  ;PrintN("PreFlags: " + Str(Flags))
    If (Flags & 2) And VersionID < 36000
      Flags = Flags - 2
      EndIf
  ;PrintN("OstFlags: " + Str(Flags))
  
  
  
  
    
    Select mode
  CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case #ctSSLayer_MusicTypeTracker
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
          CompilerIf #FMod_Always_SetCallbacks
            CallFunctionFast(*FSOUND_File_SetCallbacks, 0, 0, 0, 0, 0)
            CompilerEndIf
          Define.i size
          *SongPointer\ptrMem = ReadFileToMemory(*Filename, @size, UnicodeStr)
          If *SongPointer\ptrMem
;FSOUND_LOADMEMORY  =    &H8000        ' For FSOUND_Sample_Load - name will be interpreted as a pointer to data
;FSOUND_NONBLOCKING = &H1000000    ' For FSOUND_Stream_Open - Causes stream to open in the background and not block the foreground app - stream plays only when ready.
;                       1008000    ' For FSOUND_Stream_Open - Causes stream to open in the background and not block the foreground app - stream plays only when ready.
            If VersionID > 36999
              ;If (Flags & 2)
                ;FlagsNew = $1000000
                ;*SongPointer\BlockWait = 1
                ;EndIf
              *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSongEx, *SongPointer\ptrMem, 0, size, $8001, 0, 0);"_FMUSIC_LoadSongEx@24")
              ElseIf VersionID > 36299
              ;If (Flags & 2)
                ;FlagsNew = $1000000
                ;*SongPointer\BlockWait = 1
                ;EndIf
              *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSongEx, *SongPointer\ptrMem, size, $8001, 0, 0);"_FMUSIC_LoadSongEx@20")
              ElseIf VersionID > 36199
              *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSongEx, *SongPointer\ptrMem, size, $8001, 0, 0);"_FMUSIC_LoadSongEx@20")
              Else
              *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSongEx, *SongPointer\ptrMem, size) ;"_FMUSIC_LoadSongMemory@8")
              EndIf
;Debug "Loader: " + Str(*SongPointer\Pointer)
            If *SongPointer\Pointer = 0
              LocalFree_(*SongPointer\ptrMem)
              *SongPointer\ptrMem = 0
              EndIf
            EndIf
          ;*SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSong, *SongPointer)
          CompilerElse
          ;CompilerIf #FMod_Always_SetCallbacks
          ;  CallFunctionFast(*FSOUND_File_SetCallbacks, 0, 0, 0, 0, 0)
          ;  CompilerEndIf
          *SongPointer\Pointer = CallFunctionFast(*FMUSIC_LoadSong, FilenameAnsi)
          CompilerEndIf
        If *SongPointer\Pointer
          *SongPointer\Size = CallFunctionFast(*FMUSIC_GetNumOrders, *SongPointer\Pointer)
          EndIf
  CompilerEndIf
  
  
  
  CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      Case #ctSSLayer_MusicTypeInetStream
        If (Flags & 2)
          FlagsNew = $1000000
          *SongPointer\BlockWait = 1
          EndIf
  ;PrintN("Internet with FlagsNew: " + Str(FlagsNew))
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
          CompilerIf #FMod_Always_SetCallbacks
            CallFunctionFast(*FSOUND_File_SetCallbacks, 0, 0, 0, 0, 0)
            CompilerEndIf
          ;FilenameAnsi = MkFakeFilename(FilenameAnsi, *SongPointer)
          CompilerEndIf
;Debug FilenameAnsi
        *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, @FilenameAnsi, $2001 | FlagsNew, 0, 0)
        ;mode = #ctSSLayer_MusicTypeInetStream
        *SongPointer\Size = 3600000 ; 1h ; 300000 ;5 mins!
  CompilerEndIf
      Case #ctSSLayer_MusicTypeStream
        If (Flags & 1)
          FlagsNew = $20000
          EndIf
        If (Flags & 2)
          FlagsNew = FlagsNew | $1000000
          EndIf
  ;PrintN("Stream with FlagsNew: " + Hex(FlagsNew))
        If VersionID < 37000
          CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
            CompilerIf #FMod_Always_SetCallbacks
              CallFunctionFast(*FSOUND_File_SetCallbacks, @useropenc(), @userclosec(), @userreadc(), @userseekc(), @usertellc())
              CompilerEndIf
            FilenameAnsi = MkFakeFilename(FilenameAnsi, *SongPointer)
            CompilerEndIf
          *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, @FilenameAnsi, $2001 | FlagsNew, 0)
          Else
          CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
            CompilerIf #FMod_Always_SetCallbacks
              CallFunctionFast(*FSOUND_File_SetCallbacks, @useropen(), @userclose(), @userread(), @userseek(), @usertell())
              CompilerEndIf
            FilenameAnsi = MkFakeFilename(FilenameAnsi, *SongPointer)
            CompilerEndIf
          *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, @FilenameAnsi, $2001 | FlagsNew, 0, 0)
          EndIf
        If (Flags & 2)
          *SongPointer\BlockWait = 1
  ;PrintN("BlockSet")
  ;        Goto NonBlockingOpen
          ElseIf *SongPointer\Pointer
          *SongPointer\Size = CallFunctionFast(*FSOUND_Stream_GetLengthMs, *SongPointer\Pointer)
          EndIf
  CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        Global TempChar.s
        CompilerIf #ctSSLayer_CompiledFeature_LoadSongW And #FMod_Always_SetCallbacks
          CallFunctionFast(*FSOUND_File_SetCallbacks, 0, 0, 0, 0, 0)
          CompilerEndIf

        If xUseCDDA ; And ctSSLayer_CanUseItem(0)
          If xUseJitter And ctSSLayer_CanUseItem(1)
            TempChar = LCase(Left(FilenameAnsi, 2))
            *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, @TempChar, 0, 0, 0)
            Else
            TempChar = LCase(Left(FilenameAnsi, 2)) + "*j"
            *SongPointer\Pointer = CallFunctionFast(*FSOUND_Stream_Open, @TempChar, 0, 0, 0)
            EndIf
          If *SongPointer\Pointer
;Debug "a1) " + Hex(*SongPointer) + " / " + Hex(*SongPointer\Pointer)
;MessageBox_(0, Hex(*SongPointer), "a)", 0)
            xLong1 = (Val(GetTrackNumber(FilenameAnsi)) - 1) & $ff
;Debug xLong1
;Debug "a2) " + Hex(*SongPointer) + " / " + Hex(*SongPointer\Pointer)
            If (CallFunctionFast(*FSOUND_Stream_SetSubStream, *SongPointer\Pointer, xLong1))
;Debug "b) " + Hex(*SongPointer) + " / " + Hex(*SongPointer\Pointer)
;MessageBox_(0, Hex(*SongPointer), "b)", 0)
              *SongPointer\Size = CallFunctionFast(*FSOUND_Stream_GetLengthMs, *SongPointer\Pointer)
              Else
;Debug "c1) " + Hex(*SongPointer)
;MessageBox_(0, Hex(*SongPointer), "c)", 0)
;Debug "c2) " + Hex(*SongPointer\Pointer)
              CallFunctionFast(*FSOUND_Stream_Close, *SongPointer\Pointer)
              *SongPointer\Pointer = 0
              EndIf
            EndIf
          mode = #ctSSLayer_MusicTypeStream
          Else
          *SongPointer\CDTrackID = Val(GetTrackNumber(FilenameAnsi))
          If VersionID > 35999
            *SongPointer\ExtraA = Asc(Left(FilenameAnsi, 1))
            *SongPointer\Size = CallFunctionFast(*FSOUND_CD_GetTrackLength, *SongPointer\ExtraA, *SongPointer\CDTrackID)
            If *SongPointer\Size
              *SongPointer\Pointer = 1
              ;IsCDing = 1
              EndIf
            Else
            *SongPointer\CDTrackID - 1
            *SongPointer\Size = CallFunctionFast(*FSOUND_CD_GetTrackLength, *SongPointer\CDTrackID)
            If *SongPointer\Size
              *SongPointer\Pointer = 1
              ;IsCDing = 1
              EndIf
            EndIf
          EndIf
  CompilerEndIf
      EndSelect
  
  
    If *SongPointer\Pointer
  ;NonBlockingOpen:
      *SongPointer\mode = mode
      CompilerIf #ctSSLayer_CompiledFeature_ReadTags
        *SongPointer\Format_QualityMulti = GetQualityMultiByFilename(FilenameAnsi)
        CompilerEndIf
      ;If *SongPointer\Size = 0
      ;  *SongPointer\Size = 1
      ;  EndIf
      ProcedureReturn *SongPointer
      Else
      FreeMemory(*SongPointer)
      EndIf
    ;DoClearError()


CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
FileNameToLong:
CompilerEndIf
    EndIf
CompilerIf #ctSSLayer_CompiledFeature_LoadSongA And #ctSSLayer_CompiledFeature_LoadSongW
  EndProcedure
CompilerElse
  EndProcedure
CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_LoadSongA
  ProcedureDLL.i ctSSLayer_LoadSongA(mode.i, *Filename, Flags.i)
    ProcedureReturn ctSSLayer_LoadSong(mode, *Filename, Flags, 0)
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
  ProcedureDLL.i ctSSLayer_LoadSongW(mode.i, *Filename, Flags.i)
    ProcedureReturn ctSSLayer_LoadSong(mode, *Filename, Flags, 1)
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_LoadSongFinished(*SongPointer.tSong)
  Define.i xResult
  If *SongPointer\BlockWait
    Select CallFunctionFast(*FSOUND_Stream_GetOpenState, *SongPointer\Pointer)
      Case 0
        xResult = 1
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
If Not *SongPointer\mode = #ctSSLayer_MusicTypeInetStream
CompilerEndIf
        *SongPointer\Size = CallFunctionFast(*FSOUND_Stream_GetLengthMs, *SongPointer\Pointer)
        ;If *SongPointer\Size = 0
        ;  *SongPointer\Size = 1
        ;  EndIf
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
EndIf
CompilerEndIf
        *SongPointer\BlockWait = 0
      Case -2, -4, -5
      Default
        xResult = -1
      EndSelect
    Else
    xResult = 1
    EndIf
  ProcedureReturn xResult
  EndProcedure

ProcedureDLL ctSSLayer_LoadSongAbort(*SongPointer.tSong)
  Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case #ctSSLayer_MusicTypeStream, #ctSSLayer_MusicTypeInetStream
CompilerElse
    Case #ctSSLayer_MusicTypeStream
CompilerEndIf
      CallFunctionFast(*FSOUND_Stream_Close, *SongPointer\Pointer)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_FreeSong, *SongPointer\Pointer)
      CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
        If *SongPointer\ptrMem
          LocalFree_(*SongPointer\ptrMem)
          EndIf
        CompilerEndIf
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
;    Case #ctSSLayer_MusicTypeCDAudio
      ;If IsCDing
      ;  If VersionID > 35999
      ;    CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
      ;    Else
      ;    CallFunctionFast(*FSOUND_CD_Stop)
      ;    EndIf
      ;  IsCDing = 0
      ;; EndIf
CompilerEndIf
    EndSelect
  FreeMemory(*SongPointer)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
  Procedure EndSongCallbackProc(*ptrStream, Buff.i, Len.i, *UserData)
    If xCallHWnd
      If IsWindow_(xCallHWnd)
        If xCallMsg
          PostMessage_(xCallHWnd, xCallMsg, xCallParam, *UserData)
          EndIf
        Else
        xCallHWnd = 0
        EndIf
      EndIf
    EndProcedure

  ProcedureC EndSongCallbackProcC(*ptrStream, Buff.i, Len.i, *UserData)
    EndSongCallbackProc(*ptrStream, Buff, Len, *UserData)
    EndProcedure
  CompilerEndIf

; Continues LoadSong
ProcedureDLL.i ctSSLayer_LoadSongPlay(*SongPointer.tSong, Volume.i, LoopSong.i, Panning.i, Paused.i)
  Define.b xByte1

  LoopSong = 0 ;Unsure which version has looping reinit probs
  *SongPointer\CurLoop = LoopSong
  *SongPointer\CurPan = Panning
  *SongPointer\LastPosition = 0
  *SongPointer\CurVolume = Volume
  *SongPointer\IsPaused = Paused
  
  Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case #ctSSLayer_MusicTypeInetStream
      *SongPointer\ExtraA = CallFunctionFast(*FSOUND_Stream_PlayEx, -1, *SongPointer\Pointer, 0, 0)
      If Paused
        CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
        Else
        CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, Volume)
        EndIf
      CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
        If VersionID > 37499
          CallFunctionFast(*FSOUND_Stream_SetEndCallback, *SongPointer\Pointer, @EndSongCallbackProc(), *SongPointer)
          ElseIf VersionID > 32999
          CallFunctionFast(*FSOUND_Stream_SetEndCallback, *SongPointer\Pointer, @EndSongCallbackProcC(), *SongPointer)
          EndIf
        CompilerEndIf
      ProcedureReturn 1
CompilerEndIf
    Case #ctSSLayer_MusicTypeStream
      If VersionID < 35000
        *SongPointer\ExtraA = CallFunctionFast(*FSOUND_Stream_PlayEx, -1, *SongPointer\Pointer)
        If *SongPointer\ExtraA
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, Volume)
          CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
            If VersionID > 32999
              CallFunctionFast(*FSOUND_Stream_SetEndCallback, *SongPointer\Pointer, @EndSongCallbackProcC(), *SongPointer)
              EndIf
            CompilerEndIf
          If Paused
            CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 1)
            EndIf
          ProcedureReturn 1
          EndIf
        Else
        *SongPointer\ExtraA = CallFunctionFast(*FSOUND_Stream_PlayEx, -1, *SongPointer\Pointer, 0, 1)
        If *SongPointer\ExtraA
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, Volume)
          CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
            If VersionID > 37499
              CallFunctionFast(*FSOUND_Stream_SetEndCallback, *SongPointer\Pointer, @EndSongCallbackProc(), *SongPointer)
              ElseIf VersionID > 32999
              CallFunctionFast(*FSOUND_Stream_SetEndCallback, *SongPointer\Pointer, @EndSongCallbackProcC(), *SongPointer)
              EndIf
            CompilerEndIf
          If Paused = 0
            CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 0)
            EndIf
          ProcedureReturn 1
          EndIf
        EndIf
      
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      If VersionID < 37000
        If VersionID > 35999
          MUSICSetLooping(*SongPointer\Pointer, 0)
          EndIf
        Else
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      CallFunctionFast(*FMUSIC_PlaySong, *SongPointer\Pointer)
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
      If Paused
        CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, -1) ;true!
        EndIf
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      If VersionID < 37000
        If VersionID > 35999
          xByte1.b
          If LoopSong
            xByte1 = 1
            EndIf
          MUSICSetLooping(*SongPointer\Pointer, xByte1)
          EndIf
        Else
        If LoopSong
          xByte1 = 1
          EndIf
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      ProcedureReturn 1
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, *SongPointer\ExtraA, 1)
        CallFunctionFast(*FSOUND_CD_Play, *SongPointer\ExtraA, *SongPointer\CDTrackID)
        If Paused
          CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 1)
          EndIf
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, *SongPointer\ExtraA, 1)
        IsCDing = *SongPointer\ExtraA
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, 1)
        CallFunctionFast(*FSOUND_CD_Play, *SongPointer\CDTrackID)
        If Paused
          CallFunctionFast(*FSOUND_SetPaused, 1)
          EndIf
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        CallFunctionFast(*FSOUND_CD_SetPlayMode, 1)
        IsCDing = 1
        EndIf
      ProcedureReturn 1
CompilerEndIf
    EndSelect
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL.i ctSSLayer_MusicGetPattern(*SongPointer.tSong)
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicGetPatterns(*SongPointer.tSong)
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicHasFinished(*SongPointer.tSong)
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      ProcedureReturn (CallFunctionFast(*FMUSIC_IsFinished, *SongPointer\Pointer) & $ff)
      EndIf
    EndProcedure
  
  ProcedureDLL.i ctSSLayer_MusicTime(*SongPointer.tSong)
  ;  ProcedureReturn CallFunctionFast(*FMUSIC_GetTime, *SongPointer\Pointer)
    EndProcedure
  CompilerEndIf

Procedure EnumerateDrv(DsID.i)
  Define.i xLong1
  Define.i xLong2
  Define.w xInt1

  If Not OutPutListCount = #OutPutListMax
    CallFunction(*FmodDLL, "_FSOUND_SetOutput@4", DsID + 1)
    ;If (CallFunction(*FmodDLL, "_FSOUND_Init@12", 44001, 256, 2) & $ff)
    If CanInitAny()
      ;DoClearError()
      xLong2 = CallFunction(*FmodDLL, "_FSOUND_GetNumDrivers@0")
      For xLong1 = 0 To xLong2 - 1
        OutPutListDev(OutPutListCount) = DsID * $100 + xLong1
        If VersionID < 37000
          xInt1 = xLong1
          OutPutList(OutPutListCount) = PeekS(CallFunction(*FmodDLL, "_FSOUND_GetDriverName@4", xInt1))
          Else
          OutPutList(OutPutListCount) = PeekS(CallFunction(*FmodDLL, "_FSOUND_GetDriverName@4", xLong1))
          EndIf
        OutPutListCount + 1
        If OutPutListCount = #OutPutListMax: Break: EndIf
        Next
      CallFunction(*FmodDLL, "_FSOUND_Close@0")
      EndIf
    ;DoClearError()
    EndIf
  EndProcedure


XIncludeFile "ctSSLayer_Common_GetWinSysPath.pb"
XIncludeFile "ctSSLayer_Common_TestForDll.pb"

; First function called, must handle missing dll file
ProcedureDLL.i ctSSLayer_PreInit(MainHWnd.i)
  Define.f xSingle1

  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    *FmodDLL = OpenLibrary(#PB_Any, "fmod64.dll")
    CompilerElse
    *FmodDLL = OpenLibrary(#PB_Any, "fmod.dll")
    CompilerEndIf
  If *FmodDLL
    Define GetVersion.ProtoGetVersion
    GetVersion = GetFunction(*FmodDLL, "_FSOUND_GetVersion@0")
    If GetVersion
      xSingle1 = GetVersion()
      VersionID = xSingle1 * 10000
  
      If ctSSLayer_CanUseItem($20) > 19
        CloseLibrary(*FmodDLL)
        *FmodDLL = 0
        Else
        xSysPath = GetWinSysPath()
        If TestForDLL(xSysPath + "dsound.dll", $40003) = 0
          xNoDirectX = 1
          EndIf
        If Not VersionID = 37400
          WMAUsable = TestForDll(xSysPath + "wmasf.dll", $70001)
          EndIf
  
        If Not (xNoDirectX Or VersionID = 36000 Or VersionID = 36100)
          If MainHWnd
            CallFunction(*FmodDLL, "_FSOUND_SetHWND@4", MainHWnd)
            EndIf
          EnumerateDrv(1)
          EndIf
        EnumerateDrv(0)
        ProcedureReturn OutPutListCount
        EndIf
      ElseIf GetFunction(*FmodDLL, "FMOD_System_GetVersion")
      VersionID = -2
      Else
      VersionID = -1
      EndIf
    Else
    VersionID = -1
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_ReadTags
  XIncludeFile "ctSSLayer_Common_Trim.pb"

  Procedure GetTag(tagtype.i, ptrValue.i, lenValue.i, *ResultA, *ResultW, *ResultNum)
    Define.s xChar1
    ;Define.s xChar2
    Define xLong1.i
    Define xLong2.i
    Define.i xLong4
    Define.i HasPrio

  
  CompilerIf 0
;    PrintN("")
;    PrintN("")
;    PrintN(Str(lenValue) + ", " + Str(tagtype))
    If lenValue > 2
;      PrintN(Str(PeekB(ptrValue)))
;      PrintN(Str(PeekB(ptrValue + 1)))
;      PrintN(Str(PeekB(ptrValue + 2)))
      EndIf
    For xLong1 = 0 To lenValue - 1
      xLong2 = (PeekB(ptrValue + xLong1) + 256) % 256
      If xLong2 = 0
        Print("  ")
        Else
        Print(Chr(xLong2) + " ")
        EndIf
      Next
;    PrintN("")
    For xLong1 = 0 To lenValue - 1
      xLong2 = (PeekB(ptrValue + xLong1) + 256) % 256
      Print(Right("00" + Hex(xLong2), 2))
      Next
  CompilerEndIf
  
  
    If *ResultNum
      xLong1 = PeekI(*ResultNum)
      Else
      If PeekI(*ResultA) Or PeekI(*ResultW)
        xLong1 = 1
        EndIf
      EndIf
      
;MessageRequester("pre", Hex(*ResultA) + "/" + Hex(*ResultW) + "/" + Str(xLong1))
CompilerIf #Console
PrintN("Type: " + Str(TagType) + "; Len: " + Str(LenValue))
CompilerEndIf


    If ((Not tagtype = 1) Or xLong1 = 0) And lenValue
      If lenValue > 2 And (lenValue % 2) = 1
CompilerIf #Console
  If Not (tagtype = 1)
    PrintN("  OK1")
    EndIf
CompilerEndIf

        If PeekB(ptrValue) = 1 And PeekB(ptrValue + 1) = -1 And PeekB(ptrValue + 2) = -2
CompilerIf #Console
  If Not (tagtype = 1)
    PrintN("  OK2")
    EndIf
CompilerEndIf
          lenValue = (lenValue - 3) / 2
          ptrValue + 3
          If lenValue
CompilerIf #Console
  If Not (tagtype = 1)
    PrintN("  OK3")
    EndIf
CompilerEndIf
            HasPrio = 1
UTF8Hack:
            TrimW(@ptrValue, @lenValue)
            If lenValue
CompilerIf #Console
PrintN("  Type: " + Str(TagType) + "; Prio: " + Str(HasPrio) + "; Str: " + PeekS(ptrValue, lenValue, #PB_Unicode))
CompilerEndIf
              ;xChar1 = PeekS(ptrValue + xLong1, lenValue / 2, #PB_Unicode)
              xChar1 = PeekS(ptrValue, lenValue, #PB_Unicode)
              If xChar1
                If *ResultNum
                  PokeI(*ResultNum, Val(xChar1))
                  Else
                  xLong2 = ReAllocateMemory(PeekI(*ResultA), lenValue + 1)
                  If xLong2
                    PokeS(xLong2, xChar1, lenValue)
                    PokeB(xLong2 + lenValue, 0)
                    PokeI(*ResultA, xLong2)
                    EndIf
                  EndIf
                EndIf
              If *ResultNum = 0
;MessageRequester("Ansi7", PeekS(ptrValue, lenValue, #PB_Unicode))
                If (HasPrio Or PeekI(*ResultW) = 0)
                  xLong2 = ReAllocateMemory(PeekI(*ResultW), lenValue * 2 + 2)
                  If xLong2
                    CopyMemory(ptrValue, xLong2, lenValue * 2)
                    PokeW(xLong2 + lenValue * 2, 0)
                    PokeI(*ResultW, xLong2)
                    EndIf
                  EndIf
                EndIf
              EndIf
            If xLong4
              FreeMemory(xLong4)
              EndIf
            EndIf
          ProcedureReturn
          EndIf
        EndIf
  
      If PeekB(ptrValue) = 1 And lenValue = 1
        ProcedureReturn
        EndIf
      If PeekB(ptrValue) = 0 And lenValue > 1
        ptrValue + 1
        lenValue - 1
        EndIf
      xLong2 = MultiByteToWideChar_(0, 0, ptrValue, lenValue, 0, 0)
      xLong4 = AllocateMemory(xLong2 * 2 + 4)
      If xLong4
        If tagtype = 1 Or tagtype = 2 Or tagtype = 3
          ; ID1, ID2, Shoutcast
CompilerIf #Console
  If Not (tagtype = 1)
    PrintN("  OK8; Len: " + Str(lenValue) + "; StrAnsi: " + PeekS(ptrValue))
    PrintN("  OK8; Len: " + Str(lenValue) + "; StrUTF8: " + PeekS(ptrValue, -1, #PB_UTF8))
    EndIf
CompilerEndIf
          lenValue = MultiByteToWideChar_(0, 0, ptrValue, lenValue, xLong4, xLong2 + 1)
CompilerIf #Console
  If Not (tagtype = 1)
    PrintN("  OK9; Len: " + Str(lenValue) + "; NewStr: " + PeekS(xLong4, -1, #PB_Unicode) + "; Err: " + Str(GetLastError_()))
    EndIf
CompilerEndIf
;MessageRequester("Ansi", Str(lenValue) + " - " + PeekS(xLong4, -1, #PB_Unicode))
          Else
          HasPrio = 1
;MessageRequester("UTF8", Str(lenValue))
          lenValue = MultiByteToWideChar_(65001, 0, ptrValue, lenValue, xLong4, xLong2 + 1)
          EndIf
        If lenValue > 1
          lenValue - 1
          ;PokeW(xLong4 + LenValue * 2, 0)
          ptrValue = xLong4
          Goto UTF8Hack
          EndIf
        FreeMemory(xLong4)
        EndIf
;  GetTag_Lbl1:
      EndIf
    EndProcedure
  
  Procedure.i ctSSLayer_ReadSongInfo(*SongPointer.tSong, *xSongInfo.ctSSSongInfoStruct, IsUnicode.i)
    Define.i xLong1
    Define.i xLong2
    Define.i xLong3
    Define.i xLong4
    Define.i xLong5
    Define.i xLong6
    Define.ctSSSongInfoStruct xType1

CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    If *SongPointer\mode = #ctSSLayer_MusicTypeStream Or *SongPointer\mode = #ctSSLayer_MusicTypeInetStream
CompilerElse
    If *SongPointer\mode = #ctSSLayer_MusicTypeStream
CompilerEndIf
      xLong1 = CallFunctionFast(*FSOUND_Stream_GetSample, *SongPointer\Pointer)
      If xLong1
        CallFunctionFast(*FSOUND_Sample_GetDefaults, xLong1, @xType1\Format_Frequency, #Null, #Null, #Null)
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
        If *SongPointer\mode = #ctSSLayer_MusicTypeStream
          If *SongPointer\Size
            xType1\Format_BitRate = CallFunctionFast(*FSOUND_Stream_GetLength, *SongPointer\Pointer) / *SongPointer\Size * 8000
            EndIf
          EndIf
CompilerElse
        If *SongPointer\Size
          xType1\Format_BitRate = CallFunctionFast(*FSOUND_Stream_GetLength, *SongPointer\Pointer) / *SongPointer\Size * 8000
          EndIf
CompilerEndIf
        
        Select (CallFunctionFast(*FSOUND_Sample_GetMode, xLong1) & $60)
          Case $20
            xType1\Format_Channels = 1
            xType1\FormatOK = 1
          Case $40
            xType1\Format_Channels = 2
            xType1\FormatOK = 1
          EndSelect
        If xType1\FormatOK
          PokeF(@xType1\Format_QualityMulti, *SongPointer\Format_QualityMulti)
    
          RtlMoveMemory_(*xSongInfo, @xType1, SizeOf(xType1))
          EndIf
        EndIf
      
      Global strTitle.i: If strTitle: FreeMemory(strTitle): strTitle = 0: EndIf
      Global strTitleW.i: If strTitleW: FreeMemory(strTitleW): strTitleW = 0: EndIf
      Global strArtist.i: If strArtist: FreeMemory(strArtist): strArtist = 0: EndIf
      Global strArtistW.i: If strArtistW: FreeMemory(strArtistW): strArtistW = 0: EndIf
      Global strAlbum.i: If strAlbum: FreeMemory(strAlbum): strAlbum = 0: EndIf
      Global strAlbumW.i: If strAlbumW: FreeMemory(strAlbumW): strAlbumW = 0: EndIf
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      Global strIcyName.i: If strIcyName: FreeMemory(strIcyName): strIcyName = 0: EndIf
      Global strIcyNameW.i: If strIcyNameW: FreeMemory(strIcyNameW): strIcyNameW = 0: EndIf
      Global strIcyURL.i: If strIcyURL: FreeMemory(strIcyURL): strIcyURL = 0: EndIf
      Global strIcyURLW.i: If strIcyURLW: FreeMemory(strIcyURLW): strIcyURLW = 0: EndIf
CompilerEndIf
      
      If Not VersionID < 37100
        If (CallFunctionFast(*FSOUND_Stream_GetNumTagFields, *SongPointer\Pointer, @xLong6) & $ff)
          If xLong6
            For xLong1 = 0 To xLong6 - 1
              If (CallFunctionFast(*FSOUND_Stream_GetTagField, *SongPointer\Pointer, xLong1, @xLong2, @xLong3, @xLong4, @xLong5) & $ff)
                Select UCase(PeekS(xLong3))
                  Case "TITLE", "TIT2"
                    GetTag(xLong2, xLong4, xLong5, @strTitle, @strTitleW, 0)
                  Case "ARTIST", "TPE1"
                    GetTag(xLong2, xLong4, xLong5, @strArtist, @strArtistW, 0)
                  Case "ALBUM", "TALB"
                    GetTag(xLong2, xLong4, xLong5, @strAlbum, @strAlbumW, 0)
                  Case "YEAR", "TYER"
                    GetTag(xLong2, xLong4, xLong5, 0, 0, @*xSongInfo\Tag_Year)
                  Case "TRACK", "TRCK"
                    GetTag(xLong2, xLong4, xLong5, 0, 0, @*xSongInfo\Tag_TrackID)
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
                  Case "ICY-NAME"
                    GetTag(xLong2, xLong4, xLong5, @strIcyName, @strIcyNameW, 0)
                    ;If strIcyNameW
                    ;  PrintN("NW: " + PeekS(strIcyNameW, -1, #PB_Unicode))
                    ;  EndIf
                  Case "ICY-URL"
                    GetTag(xLong2, xLong4, xLong5, @strIcyURL, @strIcyURLW, 0)
                  Case "ICY-BR"
                    If *SongPointer\mode = #ctSSLayer_MusicTypeInetStream
                      GetTag(xLong2, xLong4, xLong5, 0, 0, @*xSongInfo\Format_BitRate)
                      *xSongInfo\Format_BitRate * 1000
                      ;Print("Recd: " + Str(*xSongInfo\Format_BitRate))
                      EndIf
CompilerEndIf
CompilerIf 0
                  Case "ICY-NOTICE1", "ICY-NOTICE2", "ICY-PUB", "ICY-GENRE"
                  Default
                    ;PrintN(UCase(PeekS(xLong3)))
                    Define.i A
                    Define.i W
                    gettag(xLong2, xLong4, xLong5, @A, @W, 0)
                    If A
                    ;  PrintN("  A: " + PeekS(A))
                      FreeMemory(A)
                      A = 0
                      EndIf
                    If W
;                      PrintN(UCase(PeekS(xLong3)) + ": " + PeekS(W, -1, #PB_Unicode))
                    ;  PrintN("  W: " + PeekS(W, -1, #PB_Unicode))
                      FreeMemory(W)
                      W = 0
                      EndIf
CompilerEndIf
                  EndSelect
                EndIf
              Next
            *xSongInfo\TagOK = 1
            EndIf
          EndIf
        EndIf
      If IsUnicode
        *xSongInfo\Tag_Title = strTitleW
        *xSongInfo\Tag_Artist = strArtistW
        *xSongInfo\Tag_Album = strAlbumW
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
        If *SongPointer\mode = #ctSSLayer_MusicTypeInetStream
          *xSongInfo\IR_Name = strIcyNameW
          *xSongInfo\IR_URL = strIcyURLW
          EndIf
CompilerEndIf
        Else
        *xSongInfo\Tag_Title = strTitle
        *xSongInfo\Tag_Artist = strArtist
        *xSongInfo\Tag_Album = strAlbum
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
        If *SongPointer\mode = #ctSSLayer_MusicTypeInetStream
          *xSongInfo\IR_Name = strIcyName
          *xSongInfo\IR_URL = strIcyURL
          EndIf
CompilerEndIf
        EndIf
      ProcedureReturn 1
      EndIf
    EndProcedure
  
  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsA
    ProcedureDLL.i ctSSLayer_ReadSongInfoA(*SongPointer, *xSongInfo)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 0)
      EndProcedure
    CompilerEndIf
  
  CompilerIf #ctSSLayer_CompiledFeature_ReadTagsW
    ProcedureDLL.i ctSSLayer_ReadSongInfoW(*SongPointer, *xSongInfo)
      ProcedureReturn ctSSLayer_ReadSongInfo(*SongPointer, *xSongInfo, 1)
      EndProcedure
    CompilerEndIf
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_RefreshDeviceList
  ProcedureDLL.i ctSSLayer_RefreshDeviceList(hWnd.i)
    ProcedureReturn OutPutListCount
    EndProcedure
  CompilerEndIf

; Anytime, Position = either time Or pattern And matching size
ProcedureDLL.i ctSSLayer_SeekSong(*SongPointer.tSong, SeekPosition.i)
  Define.i Result
  Define.i xLong1
  Define.i NewPause




  If SeekPosition > -1 And *SongPointer\Size > 0 And SeekPosition < *SongPointer\Size
    ;Result = -1
    Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case #ctSSLayer_MusicTypeTracker
        CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
        If (CallFunctionFast(*FMUSIC_IsFinished, *SongPointer\Pointer) & $ff)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
          CallFunctionFast(*FMUSIC_StopSong, *SongPointer\Pointer)



          NewPause = *SongPointer\IsPaused
          Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, 1)
          CallFunctionFast(*FMUSIC_SetOrder, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
          If NewPause
            *SongPointer\LastPosition = SeekPosition
            Else
            CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, 0)
            *SongPointer\IsPaused = 0
            EndIf
          
          

          Else
          *SongPointer\LastPosition = SeekPosition
          CallFunctionFast(*FMUSIC_SetOrder, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
          EndIf
CompilerEndIf
      Case #ctSSLayer_MusicTypeStream
        xLong1 = CallFunctionFast(*FSOUND_Stream_GetTime, *SongPointer\Pointer)
        CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
        If xLong1 = *SongPointer\Size
          CallFunctionFast(*FSOUND_Stream_Stop, *SongPointer\Pointer)
          CallFunctionFast(*FSOUND_StopSound, *SongPointer\ExtraA)



          
          NewPause = *SongPointer\IsPaused
          Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, 1)
          CallFunctionFast(*FSOUND_Stream_SetTime, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          If NewPause = 0
            CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 0)
            EndIf



          Else
          CallFunctionFast(*FSOUND_Stream_SetTime, *SongPointer\Pointer, SeekPosition)
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          EndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        ;If VersionID > 36100 Or SeekPosition = 0
        If SeekPosition
          If *SongPointer\IsPaused
            xLong1 = *SongPointer\LastPosition
            ElseIf VersionID > 35999
            xLong1 = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
            Else
            xLong1 = CallFunctionFast(*FSOUND_CD_GetTrackTime)
            EndIf
          EndIf
        If VersionID > 35999
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, 0)
          Else
          CallFunctionFast(*FSOUND_CD_SetVolume, 0)
          EndIf
        If xLong1 = *SongPointer\Size Or SeekPosition = 0
          If VersionID > 35999
            CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
            If VersionID > 36100
              NewPause = *SongPointer\IsPaused
              Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, 1)
              If NewPause
                If VersionID > 36100
                  CallFunctionFast(*FSOUND_CD_SetTrackTime, *SongPointer\ExtraA, SeekPosition)
                  CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
                  *SongPointer\LastPosition = SeekPosition
                  EndIf
                ;*SongPointer\IsPaused = 1
                Else
                CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 0)
                *SongPointer\IsPaused = 0
                EndIf
              Else
              Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, *SongPointer\IsPaused)
              *SongPointer\LastPosition = SeekPosition
              EndIf
            Else
            CallFunctionFast(*FSOUND_CD_Stop)
            Result = ctSSLayer_LoadSongPlay(*SongPointer, *SongPointer\CurVolume, *SongPointer\CurLoop, *SongPointer\CurPan, *SongPointer\IsPaused)
            *SongPointer\LastPosition = 0
            EndIf





          ElseIf VersionID > 36100
          CallFunctionFast(*FSOUND_CD_SetTrackTime, *SongPointer\ExtraA, SeekPosition)
          If *SongPointer\IsPaused
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
            *SongPointer\LastPosition = SeekPosition
            EndIf
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          EndIf
CompilerEndIf
      Default
        Result = 0
      EndSelect
    If Result
      Result = 1
      EndIf
    EndIf
  ProcedureReturn Result
  EndProcedure

; Activates callback for HWnd != 0
CompilerIf #ctSSLayer_CompiledFeature_EndCallBack
  ProcedureDLL.i ctSSLayer_SetEndCallback(HWnd.i, Message.i, wParam.i)
    xCallHWnd = HWnd
    xCallMsg = Message
    xCallParam = wParam
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_SetLoops
  ProcedureDLL.i ctSSLayer_SetLoop(*SongPointer.tSong, Loops.i, PosStart.i, PosEnd.i)
    ;loopcount < 1 = infinite, 0=off
    ;my: -1 / 0
    If VersionID > 36099
      *SongPointer\LoopStart = PosStart
      *SongPointer\LoopEnd = PosEnd
      *SongPointer\LoopCount = Loops
      If VersionID > 36299
        *FSOUND_Stream_SetLoopPoints = GetFunction(*FmodDLL, "_FSOUND_Stream_SetLoopPoints@12")
        *FSOUND_Stream_SetLoopCount = GetFunction(*FmodDLL, "_FSOUND_Stream_SetLoopCount@8")
        Else
        *FSOUND_Stream_SetLoopPoints = GetFunction(*FmodDLL, "_FSOUND_Stream_SetLoopPoints@12")
        EndIf
      EndIf


  If Loops
    LoopStart.i
    LoopEnd.i
    LoopCount.i
    
    EndProcedure
  CompilerEndIf


ProcedureDLL.i ctSSLayer_SetPause(*SongPointer.tSong, Pause.i)
  If Not (*SongPointer\IsPaused = Pause)
    *SongPointer\IsPaused = Pause

    Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
      Case #ctSSLayer_MusicTypeInetStream
        If Pause
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
          Else
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          EndIf
CompilerEndIf
      Case #ctSSLayer_MusicTypeStream
        If Pause
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
          CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 1)
          Else
          CallFunctionFast(*FSOUND_SetPaused, *SongPointer\ExtraA, 0)
          CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
          EndIf
        CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
      Case #ctSSLayer_MusicTypeTracker
        CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, *SongPointer\CurVolume)
        ;If Pause
        ;  If Not *SongPointer\IsPaused
  
        CallFunctionFast(*FMUSIC_SetPaused, *SongPointer\Pointer, Pause)
        If Pause
          *SongPointer\LastPosition = CallFunctionFast(*FMUSIC_GetOrder, *SongPointer\Pointer)
          EndIf
        *SongPointer\IsPaused = Pause
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
      Case #ctSSLayer_MusicTypeCDAudio
        ;*SongPointer\IsPaused = Pause
        If VersionID > 35999
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, *SongPointer\CurVolume)
          If Pause
            If Not *SongPointer\IsPaused
              *SongPointer\LastPosition = CallFunctionFast(*FSOUND_CD_GetTrackTime, *SongPointer\ExtraA)
              EndIf
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 1)
            Else
            CallFunctionFast(*FSOUND_CD_SetPaused, *SongPointer\ExtraA, 0)
            EndIf
          Else
          CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\CurVolume)
          If Pause
            If Not *SongPointer\IsPaused
              *SongPointer\LastPosition = CallFunctionFast(*FSOUND_CD_GetTrackTime)
              EndIf
            CallFunctionFast(*FSOUND_CD_SetPaused, 1)
            Else
            CallFunctionFast(*FSOUND_CD_SetPaused, 0)
            EndIf
          EndIf
        *SongPointer\IsPaused = Pause
CompilerEndIf
      EndSelect
    EndIf
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_Spectrum
  ProcedureDLL ctSSLayer_SetSpectrum(State.i)
    Define.w xInt1 = State
    State = CallFunction(*FmodDLL, "_FSOUND_DSP_GetFFTUnit@0")
    CallFunction(*FmodDLL, "_FSOUND_DSP_SetActive@8", State, @xInt1)
    EndProcedure
  CompilerEndIf

ProcedureDLL ctSSLayer_SetVolume(*SongPointer.tSong, Volume.i)
  *SongPointer\CurVolume = Volume
  Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, Volume)
CompilerEndIf


CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case #ctSSLayer_MusicTypeInetStream
      If *SongPointer\IsPaused = 0
        CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, Volume)
        EndIf
CompilerEndIf


    Case #ctSSLayer_MusicTypeStream
      CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, Volume)


CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, Volume)
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, Volume)
        EndIf
CompilerEndIf
    EndSelect
  EndProcedure

; Beware! Can be 0 ... esp. after you round it!
ProcedureDLL.i ctSSLayer_SongLength(*SongPointer.tSong)
  ProcedureReturn *SongPointer\Size
  EndProcedure

ProcedureDLL ctSSLayer_UnloadSong(*SongPointer.tSong)
  Select *SongPointer\mode
CompilerIf #ctSSLayer_CompiledFeature_InetStreams
    Case #ctSSLayer_MusicTypeStream, #ctSSLayer_MusicTypeInetStream
CompilerElse
    Case #ctSSLayer_MusicTypeStream
CompilerEndIf
      CallFunctionFast(*FSOUND_SetVolume, *SongPointer\ExtraA, 0)
      CallFunctionFast(*FSOUND_Stream_Stop, *SongPointer\Pointer)
      CallFunctionFast(*FSOUND_Stream_Close, *SongPointer\Pointer)
      CallFunctionFast(*FSOUND_StopSound, *SongPointer\ExtraA)
CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
    Case #ctSSLayer_MusicTypeTracker
      CallFunctionFast(*FMUSIC_SetMasterVolume, *SongPointer\Pointer, 0)
      CallFunctionFast(*FMUSIC_StopSong, *SongPointer\Pointer)
      CallFunctionFast(*FMUSIC_FreeSong, *SongPointer\Pointer)
      CompilerIf #ctSSLayer_CompiledFeature_LoadSongW
        If *SongPointer\ptrMem
          LocalFree_(*SongPointer\ptrMem)
          EndIf
        CompilerEndIf
CompilerEndIf
CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
    Case #ctSSLayer_MusicTypeCDAudio
      If VersionID > 35999
        CallFunctionFast(*FSOUND_CD_SetVolume, *SongPointer\ExtraA, 0)
        CallFunctionFast(*FSOUND_CD_Stop, *SongPointer\ExtraA)
        Else
        CallFunctionFast(*FSOUND_CD_SetVolume, 0)
        CallFunctionFast(*FSOUND_CD_Stop)
        EndIf
      IsCDing = 0
CompilerEndIf
    EndSelect
  FreeMemory(*SongPointer)
  EndProcedure

CompilerIf #ctSSLayer_CompiledFeature_CD_AndOr_CDDA
  ProcedureDLL ctSSLayer_UpdateCDDA(UseCDDA.i, UseJitterCorrection.i)
    If ctSSLayer_CanUseItem(0)
      xUseCDDA = UseCDDA
      xUseJitter = UseJitterCorrection
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased = 2
  ProcedureDLL ctSSLayer_UpdateLooping(*SongPointer.tSong, LoopSong.i)
    Define.b xByte1
    LoopSong = 0 ;Unsure which version has looping reinit probs
    
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      *SongPointer\CurLoop = LoopSong
      If VersionID < 37000
        If VersionID > 35999
          If LoopSong
            xByte1 = 1
            EndIf
          MUSICSetLooping(*SongPointer\Pointer, xByte1)
          EndIf
        Else
        If LoopSong
          xByte1 = 1
          EndIf
        MUSICSetLooping(*SongPointer\Pointer, xByte1)
        EndIf
      EndIf
    EndProcedure
  CompilerEndIf

CompilerIf #ctSSLayer_CompiledFeature_MusicPatternBased
  ProcedureDLL ctSSLayer_UpdatePanning(*SongPointer.tSong, Panning.i)
    If *SongPointer\mode = #ctSSLayer_MusicTypeTracker
      *SongPointer\CurPan = Panning
      MUSICSetPanSeperation(*SongPointer\Pointer, Panning / 100)
      EndIf
    EndProcedure
  CompilerEndIf

ProcedureDLL.i ctSSLayer_Version(OptionalLayerVersionID.i)
  Select OptionalLayerVersionID
    Case 0, $10000682, $10000690, $10001010, $10001020, $10001100, $10001101
      ProcedureReturn $10001101
    EndSelect
  EndProcedure

CompilerIf #False
AttachProcess(0)
If ctSSLayer_Version($10001101)
  Debug "1"
  If ctsslayer_preinit(55)
    ;Debug ctsslayer_canuseitem($20)
    ;Debug ctsslayer_canuseitem($21)
    Debug PeekS(ctsslayer_getinfostringa($1)) + " " + PeekS(ctsslayer_getinfostringa($30))
    ;Debug VersionID
    If ctsslayer_init(0, 0, 1, 0)
      Debug "inited"
      ;Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeCDAudio, @"r:\track01.cda", 1)
      Define.i xLong1 = ctsslayer_loadsonga(#ctSSLayer_MusicTypeInetStream, @"http://91.121.13.103:8080", 3)
      If xLong1
        Debug "loadok"
        Delay(2000)
        Debug ctsslayer_loadsongplay(xLong1, 255, 0, 80, 0)
        ;Repeat
        ;  Delay(100)
        ;  ForEver
        Delay(20000)
        EndIf
      EndIf
    EndIf
  EndIf

DetachProcess(0)
CompilerEndIf

;Define *Mem = AllocateMemory(2000)
;PokeS(*Mem, "ThisIsATestFile.mp4", -1, #PB_Unicode)
;Debug PeekS(UnFakeFilename(MkFakeFilename("AnsiStr.mp3", *Mem)), -1, #PB_Unicode)
; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; ExecutableFormat = Shared Dll
; CursorPosition = 735
; FirstLine = 735
; Folding = ----------------------------------------
; Executable = ..\Calaym64\ctssly64.dll
; CompileSourceDirectory
; IncludeVersionInfo
; VersionField0 = 1,0,0,5600
; VersionField1 = 1,0,0,5600
; VersionField2 = ctuser
; VersionField3 = ctSSLayer
; VersionField4 = 1.00 beta 56
; VersionField5 = 1.00 beta 56 (2006.09.23)
; VersionField6 = FMod sound system layer
; VersionField7 = ctSSLay
; VersionField8 = ctSSLay.dll
; VersionField9 = Copyright 2002-2006 by Jan Vorel; Published under the GNU General Public License
; VersionField16 = VFT_DLL
; VersionField18 = Comments
; VersionField21 = Published under the GNU General Public License; homepage: http://www.ctuser.net; Uses FMod soundsystem: http://www.fmod.org; compressed with upx: http://upx.sourceforge.net
; AddResource = ctSSLayer_FMod.rc