EnableExplicit

LibBuild_Include(BitmapFromWEMFEx)

Procedure.i BitmapFromWEMF(hMeta, Width, Height, BgColor.i, *ColorFixer)
  Define.i xResult
  Define.i hDC
  Define.i hBmp
  Define.i hBmpOld

  If hMeta
    hDC = GetDC_(0)
    If hDC
      hBmp = CreateCompatibleBitmap_(hDC, Width, Height)
      ReleaseDC_(0, hDC)
      If hBmp
        hDC = CreateCompatibleDC_(0)
        If hDC
          hBmpOld = SelectObject_(hDC, hBmp)
          If hBmpOld
            If BitmapFromWEMFEx(hDC, hMeta, 0, 0, Width, Height, BgColor, *ColorFixer)
              xResult = hBmp
              EndIf
            SelectObject_(hDC, hBmpOld)
            EndIf
          DeleteDC_(hDC)
          EndIf
        If Not xResult
          DeleteObject_(hBmp)
          EndIf
        EndIf
      EndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = -
; EnableUnicode
; EnableXP