﻿EnableExplicit

LibBuild_Include(GetClassName)
LibBuild_Include(WindowToCursorPos)

Procedure.i GetAPIPopupMenu(hWndCaller.i, hMenu.i, HWndControl.i)
  Define.i xResult
  Define.i xLong1
  Define.i xLong2
  Define.i xLong3
  Define.i xLong4
  Define.i xBool1_LVBShare1
  Define.POINT xType1
  Define.RECT xType2
  Define.RECT xType4
  Define.RECT xType5
  Define.POINT xMenuSize

    ;xControlMode: 10(-12 reserved) -> ListBox
    ; -1-> mouse
    ; 0 -> nospecial
    ; 1 -> centerclient
    ; 2 -> outsidecontrol
    
    ;0=SingleSel?
    ;1=extended?
    ;2=checkboxmode?
  If Not hMenu = 0
    xLong4 = CreateWindowEx_(0, @"STATIC", 0, $8000003, 0, 0, 32, 32, 0, 0, hInstance, 0)
    ;$8000000
    SetMenu_(xLong4, hMenu)
    DrawMenuBar_(xLong4)
    SetMenu_(xLong4, 0)
    DrawMenuBar_(xLong4)
    
    xLong1 = GetMenuItemCount_(hMenu)
    GetMenuItemRect_(xLong4, hMenu, xLong1 - 1, xType2)
    xMenuSize\x = xType2\Right
    xMenuSize\y = xType2\Bottom
    GetMenuItemRect_(xLong4, hMenu, 0, xType2)
    If hWndCaller
      DestroyWindow_(xLong4)
      EndIf
    
    xMenuSize\x = xMenuSize\x - xType2\Left
    xMenuSize\y = xMenuSize\y - xType2\Top
    xMenuSize\x = xMenuSize\x + (GetSystemMetrics_(7) << 1)
    xMenuSize\y = xMenuSize\y + (GetSystemMetrics_(8) << 1)
    
    If HWndControl = 0
      WindowToCursorPos(xMenuSize, xType1)
      GetOptMonitorFromPoint(xType1\x, xType1\y, xType2)
      Else
      ClientToScreen_(HWndControl, @xType1)
      GetWindowRect_(HWndControl, @xType4)
      GetOptMonitorFromPoint((xType4\Left + xType4\Right) >> 1, (xType4\Top + xType4\Bottom) >> 1, @xType2)
      xType4\Bottom - xType4\Top
      
      Select UCase(GetClassName(HWndControl))
        Case "SYSLISTVIEW32"
          xLong1 = SendMessage_(HWndControl, $100C, -1, 1)
          If xLong1 < 0
            xLong1 = 0
            EndIf
          xLong3 = SendMessage_(HWndControl, $1027, 0, 0)
          If SendMessage_(HWndControl, $100E, 0, @xType5) = 0
            xLong2 = 16
            Else
            xLong2 = xType5\Bottom - xType5\Top
            EndIf
          xBool1_LVBShare1 = #True
        Case "LISTBOX"
          xLong1 = SendMessage_(HWndControl, #LB_GETCARETINDEX, 0, 0) ;LB_GETCARETINDEX
          xLong3 = SendMessage_(HWndControl, #LB_GETTOPINDEX, 0, 0) ;LB_GETTOPINDEX
          xLong2 = SendMessage_(HWndControl, #LB_GETITEMHEIGHT, 0, 0) ;LB_GETITEMHEIGHT
          
          If Not xLong1 > xLong3 - 1
            If Not xLong1 < xLong3 + (IMath_DivURD(xType4\Bottom, xLong2)) - 1
              xLong3 = xLong1 - (((IMath_DivURD(xType4\Bottom, xLong2)) - 1) >> 1)
              If xLong3 < 0
                xLong3 = 0
                EndIf
              SendMessage_(HWndControl, #LB_SETTOPINDEX, xLong3, 0) ;LB_SETTOPINDEX
              EndIf
            EndIf
        Default
          xType1\y = xType4\Bottom / 4
          If xType4\Top + xType4\Bottom - xType1\y + xMenuSize\y > xType2\Bottom
            xType1\y = xType4\Top + xType1\y - xMenuSize\y
            Else
            xType1\y = xType4\Top + xType4\Bottom - xType1\y
            EndIf
          xType1\x = (xType4\Right - xType4\Left) / 4
          If xType4\Left + xType1\x + xMenuSize\x > xType2\Right
            xType1\x = xType4\Right - xType1\x - xMenuSize\x
            Else
            xType1\x = xType4\Left + xType1\x
            EndIf
        EndSelect



      If xBool1_LVBShare1
        xLong1 = xLong1 - xLong3
        ;Stop
        If xType1\y + (xLong1 + 1.25) * xLong2 + xMenuSize\y > xType2\Bottom
          xType1\y = xType1\y - xMenuSize\y + (xLong1 - 0.25) * xLong2
          Else
          xType1\y = xType1\y + (xLong1 + 1.25) * xLong2
          EndIf
          
            ; center l/r
        xType4\Right = xType4\Right - xType4\Left
        If xType4\Right > xMenuSize\x
          xType1\x = xType1\x + (xType4\Right - xMenuSize\x) >> 1
          EndIf
        EndIf


      
      
      If xType1\x + xMenuSize\x > xType2\Right
        xType1\x = xType2\Right - xMenuSize\x
        EndIf
      If xType1\y + xMenuSize\y > xType2\Bottom
        xType1\y = xType2\Bottom - xMenuSize\y
        EndIf
      EndIf
    If xType1\x < xType2\Left
      xType1\x = xType2\Left
      EndIf
    If xType1\y < xType2\Top
      xType1\y = xType2\Top
      EndIf
    
    CompilerIf Defined(LibBuild_ToolTip_Included, #PB_Constant)
      ToolTip_DisableInt()
      CompilerEndIf
    If hWndCaller = 0
      xLong2 = GetForegroundWindow_()
      SetForegroundWindow_(xLong4)
      DoEvents()
      SetForegroundWindow_(xLong4)
      xResult = TrackPopupMenuEx_(hMenu, #TPM_PopupMenuRecommend, xType1\x, xType1\y, xLong4, 0)
      If xLong2 And xResult
        SetForegroundWindow_(xLong2)
        EndIf
      DestroyWindow_(xLong4)
      Else
      xResult = TrackPopupMenuEx_(hMenu, #TPM_PopupMenuRecommend, xType1\x, xType1\y, hWndCaller, 0)
      PostMessage_(hWndCaller, 0, 0, 0)
      EndIf
    CompilerIf Defined(LibBuild_ToolTip_Included, #PB_Constant)
      ToolTip_IsEnabledInt = #True
      CompilerEndIf
    EndIf
  ProcedureReturn xResult
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 152
; FirstLine = 135
; Folding = -
; EnableUnicode
; EnableXP