﻿EnableExplicit

Procedure.s SizeToXiBString(xDbl1.q, NumDecimals.i, ForceDecimals.i, OverFlowShift.i)
  Define.s xResult
  If xDbl1 < ($400 << OverFlowShift) And Not ForceDecimals
    xResult = Str(xDbl1) + " Byte"
    ElseIf xDbl1 < ($100000 << OverFlowShift)
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " KiB"
    ElseIf xDbl1 < ($40000000 << OverFlowShift)
    xDbl1 = xDbl1 >> 10
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " MiB"
    ElseIf xDbl1 < ($10000000000 << OverFlowShift)
    xDbl1 = xDbl1 >> 20
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " GiB"
    ElseIf xDbl1 < ($4000000000000 << OverFlowShift)
    xDbl1 = xDbl1 >> 30
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " TiB"
    ElseIf xDbl1 < ($1000000000000000 << OverFlowShift)
    xDbl1 = xDbl1 >> 40
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " PiB"
    Else
    xDbl1 = xDbl1 >> 50
    xResult = StrF(xDbl1 / 1024, NumDecimals) + " EiB"
    EndIf
  ProcedureReturn xResult
  EndProcedure

;Debug SizeToXiBString(4 * 1024*1024*1024, 0, #False, 2)
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 27
; FirstLine = 9
; Folding = -
; EnableUnicode
; EnableXP