EnableExplicit

LibBuild_Include(WinSock_Base)

Procedure.i WinSock_Connect(Hostname.s, Port.i, TimeOut.i = 4000)
  Define.i lngHostName
  Define.sockaddr_in udtSockaddr
  Define.i xLong1
  Define.i hEvent
  Define.i Result

  Result = SOCKET_(2, 1, 6)
;Debug "Socket:" + Str(Result)
  If Result > 0
    lngHostName = inet_addr_(Hostname)
    CompilerIf Defined(LibBuild_WinSock_GetHostByName_Included, #PB_Constant)
      If lngHostName = 0 Or lngHostName = -1
        lngHostName = WinSock_GetHostByName(Hostname)
        EndIf
      CompilerEndIf
    If Not (lngHostName = 0 Or lngHostName = -1)
      With udtSockaddr
        \sin_family = 2
        \sin_addr = lngHostName
        \sin_port = htons_(Port)
        EndWith
      hEvent = WSACreateEvent()
      If hEvent
        If WSAEventSelect(Result, hEvent, $10) = 0
          ioctlsocket_(Result, $8004667E, 1)
          xLong1 = connect_(Result, udtSockaddr, 16)
          If xLong1 = -1
            xLong1 = WSAGetLastError_()
            If xLong1 = 0 Or xLong1 = 10035
              xLong1 = WSAWaitForMultipleEvents(1, @hEvent, 0, TimeOut, 0)
              If Not xLong1 = $102
                Goto IsOK
                EndIf
              EndIf
            ElseIf xLong1 = 0
IsOK:
            WSAEventSelect(Result, 0, 0)
            WSACloseEvent(hEvent)
            hEvent = 0
            ioctlsocket_(Result, $8004667E, 1)
            ProcedureReturn Result
            EndIf
          If hEvent
            WSAEventSelect(Result, 0, 0)
            EndIf
          EndIf
        If hEvent
          WSACloseEvent(hEvent)
          EndIf
        EndIf
      EndIf
    closesocket_(Result)
    EndIf
  ProcedureReturn 0
  EndProcedure

; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 12
; FirstLine = 1
; Folding = -
; EnableUnicode
; EnableXP