EnableExplicit

LibBuild_CheckPriority(WinSock_Connect)

Procedure.i WinSock_GetHostByName(xHostname.s)
  CompilerIf #PB_Compiler_Processor = #PB_Processor_x64
    Define.hostent *xType1
    Define.i xLong1

    PokeS(*ptrTemp, xHostname, -1, #PB_Ascii)
    *xType1 = gethostbyname_(*ptrTemp)
    If *xType1
      If *xType1\h_addr_list
        xLong1 = PeekI(*xType1\h_addr_list)
        If xLong1
          xLong1 = PeekL(xLong1)
          EndIf
        EndIf
      EndIf
    ProcedureReturn xLong1
    CompilerElse
    Define.i xLong1
    Define.i xLong2

    CompilerIf #PB_Compiler_Unicode
      PokeS(*ptrTemp, xHostname, -1, #PB_Ascii)
      xLong1 = gethostbyname_(*ptrTemp)
      CompilerElse
      xLong1 = gethostbyname_(xHostname)
      CompilerEndIf

    If xLong1
      If (GetVersion_() & $80000000)
        xLong1 + 16
        RtlMoveMemory_(@xLong2, xLong1, 4)
        If xLong2
          RtlMoveMemory_(@xLong1, xLong2, 4)
          ProcedureReturn xLong1
          EndIf
        Else
        xLong1 + 12
        RtlMoveMemory_(@xLong2, xLong1, 4)
        If xLong2
          RtlMoveMemory_(@xLong1, xLong2, 4)
          If xLong1
            RtlMoveMemory_(@xLong2, xLong1, 4)
            ProcedureReturn xLong2
            EndIf
          EndIf
        EndIf
      EndIf
    CompilerEndIf
  EndProcedure
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 4
; FirstLine = 1
; Folding = -
; EnableUnicode
; EnableXP