﻿EnableExplicit

XIncludeFile "ctSSLayer_Common_MakeUnicode.pb"

CompilerIf #ctSSLayer_Common_Debugger
  Declare SendToDebugger(xChar1.s, Flags.i)

  CompilerIf #ctSSLayer_Common_DebuggerA
    ProcedureDLL.i ctSSLayer_SetDebuggerA(*DebuggerCB)
      Global *Debugger
      Global DebuggerIsWide
      ;                             gglm ; group, (detail)level, misc)
      #ctSSLayer_DbgFlag_Grp_None = $0000
      #ctSSLayer_DbgFlag_Grp_Tags = $8000
      #ctSSLayer_DbgFlag_Grp_CDDA = $4000
      ;Levels: 0+ = generic, 2+ = toapp, 4+ = layerint, 8+ = soundsystem
      #ctSSLayer_DbgFlag_Lvl_LoP = $00 ; Low Priority (insifignant)
      #ctSSLayer_DbgFlag_Lvl_HiP = $10 ; High Important
      #ctSSLayer_DbgFlag_Lvl_Gen = $00 ; always good generic info, environment etc
      #ctSSLayer_DbgFlag_Lvl_App = $20 ; calling app related
      #ctSSLayer_DbgFlag_Lvl_Lay = $40 ; this layer internal
      #ctSSLayer_DbgFlag_Lvl_Snd = $80 ; sound system dll
      #ctSSLayer_DbgFlag_Msc_Sub =  $1 ; subinfo, intent
      
      *Debugger = *DebuggerCB
      DebuggerIsWide = #False
      SendToDebugger("Debugger attached (ansi)", #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_App | #ctSSLayer_DbgFlag_Grp_None)
      EndProcedure
    CompilerEndIf
  
  CompilerIf #ctSSLayer_Common_DebuggerW
    ProcedureDLL.i ctSSLayer_SetDebuggerW(*DebuggerCB)
      *Debugger = *DebuggerCB
      DebuggerIsWide = #True
      SendToDebugger("Debugger attached (widechar)", #ctSSLayer_DbgFlag_Lvl_LoP | #ctSSLayer_DbgFlag_Lvl_App | #ctSSLayer_DbgFlag_Grp_None)
      EndProcedure
    CompilerEndIf

  Procedure SendToDebugger(xChar1.s, Flags.i)
    If *Debugger
      If DebuggerIsWide
        InfoString = xChar1
        MakeUnicode()
        CallFunctionFast(*Debugger, InfoStringW, Flags)
        Else
        InfoString = xChar1
        CallFunctionFast(*Debugger, @InfoString, Flags)
        EndIf
      EndIf
    EndProcedure

  Procedure SendToDebuggerEx(*Ptr, Flags.i)
    If *Debugger
      CallFunctionFast(*Debugger, *Ptr, Flags)
      EndIf
    EndProcedure
  CompilerElse
  Macro SendToDebugger(xChar1, Flags)
    EndMacro
  Macro SendToDebuggerEx(*Ptr, Flags)
    EndMacro
  CompilerEndIf
; IDE Options = PureBasic 5.21 LTS (Windows - x64)
; CursorPosition = 14
; Folding = --
; EnableUnicode
; EnableXP